/*
#$Id: kxyEdtWn.js,v 1.1.2.1 2009/07/17 05:47:53 dcc Exp $#
######################################################################
# Copyright 1999-2003, Candle Corporation, a California corporation.  
# All rights reserved. International copyright secured.
#
# This material is proprietary to Candle Corporation and is not to be
# reproduced, used, or disclosed except in accordance with program
# licenses or upon written authorization of Candle Corporation.
#
#######################################################################*/
/**********************************************************************************************
					kxyEdtWn.js
***********************************************************************************************/

var headerEOpen = 0;
var propertyEOpen = 0;
var rootName = "";
var kxySystemType = "";
var HexPathNested = "";
var fieldOnFocus = 0;

var CachedImages = new Array(4);

//Fill the array with images
CachedImages[0] = new Image;
CachedImages[0]="images/msg_menu.gif";
CachedImages[1] = new Image;
CachedImages[1]="images/plus.gif";
CachedImages[2] = new Image;
CachedImages[2]="images/minus.gif";
CachedImages[3] = new Image;
CachedImages[3]="images/white.gif";


function openNestedEditor(path, nodeString, cVal, c, HexPath)
{
	if(HexPathNested == "")
		var HexPath_local = HexPath;
	else
		var HexPath_local = HexPathNested + "." + HexPath;
	
	if(cVal.length != 0)
		var node = nodeString[cVal].childNodes;
	else
		var node = nodeString;

	if(message.length != 0)
	{
		XMLPATH = "/*/*/Message[Header/KXY/ConnId="+con+"]/Body"+path;
		var xmlOb = getXMLTag(XMLPATH,XMLDOMobj);	
	}
	else
	{
		var xmlOb = getXMLTag(path,XMLDOMobj);
	}

	var kxyTypeNested = xmlOb.getAttribute("kxyType");
	var kxyFormatNested = xmlOb.getAttribute("kxyFormat");
	var kxyCCSIDNested = xmlOb.getAttribute("kxyCCSID");
	var kxySystemTypeNested = xmlOb.getAttribute("kxySystemType");
	
	if(kxySystemTypeNested == null)
		kxySystemTypeNested = "";
		
	var xmlObject;

	if(kxyTypeNested == 'STANDALONE' || kxyTypeNested == 'RAW_TEXT' || kxyTypeNested == 'RAW_HEXA')
	{
		metaD=null;
		xmlObject = xmlOb;
	}
	else
	{
		if(kxyFormatNested != null && kxyFormatNested != "")
		  {
		  	
			  metaD=S_getMetaData(kxyFormatNested);
			}
		else
			metaD=null;
		xmlObject = xmlOb;
	}

	var valid = 1;

	if(metaD  && getTag(RETURNCODE,metaD,browser) != "Success")
	{
		M_alert(getTag(EXPL,metaD,browser),getTag(EXCEPTION,metaD,browser),getTag(CCODE,metaD,browser),getTag(RCODE,metaD,browser));
		valid = 0;
	}

	if(valid == 1)
	{
		if(QType == TYPEMQ)
			var returnVal = ShowWindow('kxyEdtFr','','700px','650px',[xmlObject.cloneNode("true"),metaD,'',con,"",kxyTypeNested,getHandle(),getBackConnid(),getQType(),getActiveQmgr(),getQueueName(),getBrowser(),readOnly,kxyCCSIDNested,url,mbcsXML,kxySystemTypeNested, HexPath_local]);
		else
			var returnVal = ShowWindow('kxyEdJMF','','700px','650px',[xmlObject.cloneNode("true"),metaD,'',con,"",kxyTypeNested,getHandle(),getBackConnid(),getQType(),getActiveQmgr(),getQueueName(),getBrowser(),readOnly,kxyCCSIDNested,url,mbcsXML,kxySystemTypeNested, HexPath_local]);
	
		if(returnVal != undefined)
		{
			if(returnVal[1] == 'RAW_TEXT' || returnVal[1] == 'RAW_HEXA')
			{
				var txtNode = AuxXMLObj.createTextNode(returnVal[0]);
				if(cVal.length != 0)
				{
					while(node[c].childNodes.length != 0)
					{
						var obj = node[c].childNodes[0];
						node[c].removeChild(obj);
					}
					if(xmlObject.nodeName == "MessageData")
					{
						var bytesNode = AuxXMLObj.createElement("Bytes");
						node[c].appendChild(bytesNode);
					}
					else
						node[c].appendChild(txtNode);
						
				}
				else
				{
					while(xmlOb.childNodes.length != 0)
					{
						var obj = xmlOb.childNodes[0];
						xmlOb.removeChild(obj);
					}
					if(xmlObject.nodeName == "MessageData")
					{
						var bytesNode = AuxXMLObj.createElement("Bytes");
						xmlOb.appendChild(bytesNode);
					}
					else
						xmlOb.appendChild(txtNode);
				}
				if(xmlObject.nodeName == "MessageData")
					bytesNode.appendChild(txtNode);
		
			}
			if(returnVal[1] == 'STANDALONE' || returnVal[1] == 'MDR_RAW' || returnVal[1] == 'MDR_XML')
			{
				if(cVal.length != 0)
				{
					while(node[c].childNodes.length != 0)
					{
						var obj = node[c].childNodes[0];
						node[c].removeChild(obj);
					}
				}
				else
				{
					while(xmlOb.childNodes.length != 0)
					{
						var obj = xmlOb.childNodes[0];
						xmlOb.removeChild(obj);
					}
				}

				if (document.implementation && document.implementation.createDocument)
				 {
					// netscape 6.x+ support
					var newObj = document.implementation.createDocument("","", null);  
				 }
				 else if (window.ActiveXObject)
				 {
					  // ie 5.x+ support
					  var newObj = new ActiveXObject("MSXML2.DOMDocument");//new ActiveXObject("Microsoft.XMLDOM");	  
				 }
				 
				 newObj.loadXML(returnVal[0]);

				 if(returnVal[1] == "MDR_RAW" || returnVal[1] == "MDR_XML")
				 	newObj = newObj.firstChild;
				
				 var tempLen = newObj.childNodes.length;
				 for(var q = 0; q < tempLen; q++)
				 {
				 	xmlOb.appendChild(newObj.childNodes[0]);
				 }
				 
			}
			if(kxyTypeNested != returnVal[1])
			{
				if(cVal.length != 0)
					node[c].setAttribute("kxyType") = returnVal[1];
				else
					xmlOb.setAttribute("kxyType") = returnVal[1];
			}
		}
	}
}




function checkEnter(e)
{
	if(window.event || !e.which) // IE
	{
		key = e.keyCode; // for IE, same as window.event.keyCode
	}
	else if(e) // netscape
	{
		key = e.which;
	}
   	if (key == 13)
    	{
    		if(fieldOnFocus == 6)
    	    	{
	    		e.returnValue = false;
			var setCaretVal = document.XMLTreeForm.set_caret.value;
			if(rtrim(ltrim(setCaretVal)).length != 0)
			{
				updateTotalBytes(returnXML);			
				var tempTotalB = document.XMLTreeForm.total_bytes.value;
				
				var valid = setCaretToPos(document.XMLTreeForm.XMLEntry,setCaretVal);
				if(valid == 1)
				{
					if(setCaretVal < parseInt(tempTotalB))
						document.XMLTreeForm.current_pos.value = setCaretVal;
					else
						document.XMLTreeForm.current_pos.value = tempTotalB;
				}
				else
					document.XMLTreeForm.current_pos.value = "";
			}
		}
		else
    		if(fieldOnFocus == 5)
    		{
    			e.returnValue = false;
    			setCursorTable(44);
    		}
    		else
		if(fieldOnFocus == 2)
		{
			e.returnValue = false;
			setCursorDialog(63);
		}
		else
		if(fieldOnFocus == 3)
		{
			e.returnValue = false;
			setCursorTable(45);
		}
		else
		{
			if(document.XMLTreeForm.XMLEntry == null)
			{
			    setCursorDialog(75);
			    e.returnValue = false;
			}
			else
			{
				if(fieldOnFocus == 1)
				{
					e.returnValue = false;
					setCursorDialog(75);
				}
				else
					e.returnValue = true;
			}
		}
	}
	if (key == 27)
		setCursorDialog(63);
	if(key == 116)
	{
		cancelKey(e);
		if(document.XMLTreeForm.raw_type != null && document.XMLTreeForm.raw_type[0].checked)
		{
			updateTotalBytes(returnXML);
			
			var setCaretVal = document.XMLTreeForm.set_caret.value;
			var valid = 2;
			if(rtrim(ltrim(setCaretVal)).length != 0)
			{
				valid = setCaretToPos(document.XMLTreeForm.XMLEntry,setCaretVal);
			}
			if(valid == 2  && fieldOnFocus != 6)
			{
				textStatus = 1;
				storeCaret(e);
				if(document.XMLTreeForm.total_bytes.value > 100000)
					textStatus = 0;
			}
			else
			if(valid == 1)
			{			
				var tempTotalB = document.XMLTreeForm.total_bytes.value;
				
				if(setCaretVal < parseInt(tempTotalB))
					document.XMLTreeForm.current_pos.value = setCaretVal;
				else
					document.XMLTreeForm.current_pos.value = tempTotalB;		
			}
			else
			if(valid == 0)
				document.XMLTreeForm.current_pos.value = "";
		}
	}
}



function cancelKey(evt) {
     if (evt.preventDefault) {
         evt.preventDefault();
         return false;
     }
     else {
         evt.keyCode = 0;
         evt.returnValue = false;
     }
 }



function showAll(){

if(mes_length > 15000){
	M_alert(err_237);
	if(rootI != null)
	{
			subNodes('node3',node3,'1',rootI,1,'/','','');
	}
}
else{
var html = "";

if(message.length != 0)
{
	var nodeVal = getXMLTag("/*/*/Message[Header/KXY/ConnId="+con+"]",XMLDOMobj);
	nodeVal = nodeVal.childNodes;
	var nodeString = "XMLobj.childNodes"; 
	html += showAllProperties(nodeString,nodeVal,'1',1,0,'/','','');
}
else
{
	var nodeVal = XMLobj;
	var nodeString = "XMLobj";
	html += showAllProperties(nodeString,nodeVal,'1','',1,'/','','');
}

html += "<div id='treeSub1.1'></div>";

document.getElementById('treeSub1').innerHTML = html;
document.getElementById('treeSub1').style.display = "block";
expandNode(1);
}
}



function showAllProperties(nodeString,nodeVal,divVal,cVal,iter,parentPath,TestFlag,hexPATH)
{
	var iterate = 0;
	var nodeS;
	var divS;
	var cValS;
	var iterS;
	var parentPathS;
	var TestFlagS;
	var hexPATHS;

	////////////////////////////////////////////////////////////////////////////////////////////
	var HexIndex = new Array();

	var array1 = nodeString;
	var array2 = nodeVal;
	var array3 = divVal;
	var array4 = cVal;
	var array5 = iter;
	var array6 = parentPath;
	var array7 = hexPATH;

	var tree = "";
	if(cVal.length != 0)
	{
		var nodeValue = nodeString + "[" + cVal + "].childNodes";
		var nodeVal = nodeVal[cVal];
	}
	else
	{
		var nodeValue = nodeString + ".childNodes";
		var nodeVal = nodeVal;
	}

	var parent = nodeVal;

	var textMaxLength;
	var iter = parseInt(iter);
	var iteration = iter + 1;
	nodeVal = nodeVal.childNodes;
	
	for(var c = 0; c != nodeVal.length; c++)
	{

		  if((nodeVal[c].nodeType == 3 || nodeVal[c].nodeType == 4) && rtrim(ltrim(nodeVal[c].nodeValue)).length != 0){
		  		for(i=0;i<iteration;i++){
		  					tree += '<img src='+CachedImages[3]+' />';
				}
		  		tree += "\t\t<font class='dark'><input type = text size = 30 value = \"" + checkQuotes(rtrim(ltrim(nodeVal[c].nodeValue))) + "\" ";
		  		if(checkReadOnlyOption()){
						tree += " disabled ";
  				}
		  		tree += " onKeyUp='"+nodeValue+"["+c+"].nodeValue=this.value' onMouseOut='"+nodeValue+"["+c+"].nodeValue=this.value' ></font><br/>";

		  }
		  else		
		  if(nodeVal[c].nodeName != "#text")
		  {
			if(hexPATH != "" || hexPATH != null)
				HexPath = hexPATH ;


			if(HexIndex[nodeVal[c].nodeName] == null)
				HexIndex[nodeVal[c].nodeName] = 0;
			else
				HexIndex[nodeVal[c].nodeName] += 1;

			if(nodeVal[c].nodeName == rootName){

				path = parentPath ;
				var auxPath = '//Body/Properties'+path;
						var max = 0;
						var min = 0;
						//var temp = null;

			}
			else{

				path = parentPath + "/" + nodeVal[c].nodeName;

				if(message.length != 0)
					var auxPath = '//Body/Properties'+path;
				else
					var auxPath = path;

				if(HexPath != "")
					HexPath += "."+ nodeVal[c].nodeName;
				else
					HexPath = nodeVal[c].nodeName;

				var max = MaxCard(AuxXMLObj,auxPath);
				var min = MinCard(AuxXMLObj,auxPath);
				var maxLen = MaxLength(AuxXMLObj,auxPath);
				var minLen = MinLength(AuxXMLObj,auxPath);
				var type = getTypeAttribute(AuxXMLObj,auxPath);

				if(message.length != 0)
					var temp = getXMLTag("/*/*/Message[Header/KXY/ConnId="+con+"]/Body"+path,XMLDOMobj);
				else
					var temp = getXMLTag(path,XMLDOMobj);

				if(browser == "NS")
					temp = temp.iterateNext();
			}
			if(min != max)
				HexPath += "["+ HexIndex[nodeVal[c].nodeName] + "]";


			var count = parent.childNodes.length;
			current = 0;
			for(i=0;i<count;i++){
				if(parent.childNodes[i].nodeName == nodeVal[c].nodeName)
					current = current + 1;
			}

			for(i=0;i<iteration;i++){
				tree += '<img src='+CachedImages[3]+' />';
			}

			if(kxySystemType != "" && (nodeVal[c].nodeName == "ValueData" || nodeVal[c].nodeName == "Message" || nodeVal[c].nodeName == "MessageData"))
			{
				if(parentPath == "/")
					var pathNested = parentPath + "*[" + c + "]";
				else
					var pathNested = parentPath + "/*[" + c + "]";
				tree += "&nbsp;&nbsp;<a href='#' class='list' onClick=openNestedEditor('"+pathNested+"',"+ nodeString +",'"+cVal+"',"+c+",'"+HexPath+"') ><font class='dark'><b>" + nodeVal[c].nodeName + "</b></font></a><br/>";

			}
			else
			{
				var valid = 0;
				if(browser == "NS"){
					if(nodeVal[c].childNodes.length > 1)
						valid = 1;
				}
				else{
					if(nodeVal[c].childNodes.length != 0)
						valid = 1;

					if(nodeVal[c].childNodes.length == 1 && (nodeVal[c].childNodes[0].nodeType == 3 || nodeVal[c].childNodes[0].nodeType == 4))
						valid = 0;
				}

				if(valid == 1 )
				{
					iterate = 1;
					nodeS = nodeVal;
					var divS = divVal + '.' + c + '';
					var cValS = c+'';
					var iterS = iteration + '';
					var parentPathS = path + '';
					var TestFlagS ='';
					var hexPATHS = HexPath + '';

					tree += '<img src='+CachedImages[2]+' id= "img'+divVal+'.'+c+'" height=12 width=12 onClick=subNodes("' + nodeValue + '",' + nodeValue + ',"' + divVal + '.' + c + '","' + c + '","'+iteration+'","'+path+'","","'+HexPath+'");>';
					if(temp != null && max != 0)
						tree += "<img align='middle' src="+CachedImages[0]+" onMouseOut=hidePopupMenu('menuT') onMouseDown=onMouseDownHandlerEd(event,'" + nodeVal[c].nodeName + "'," + nodeValue + ",'"+c+"','"+path+"','"+max+"','"+min+"','"+current+"','"+HexPath+"','"+type+"');setNodeValues('"+array1+"',"+array1+",'"+array3+"','"+array4+"','"+array5+"','"+array6+"','"+array7+"') >";
					else
						tree += "&nbsp;&nbsp;";
					tree += '<font class="dark"><b>' + nodeVal[c].nodeName + '</b></font>';
					if(min != null && max != null && max != 0)
					if(temp != null && temp == nodeVal[c]  ){
								tree += "&nbsp;&nbsp;&nbsp;&nbsp;<font class='MessageAttrib'><b>";
								if(type != null)
									tree += "Type = "+type+"&nbsp;&nbsp;"; 
								if(minLen != null && maxLen != null)
									tree += "Min Len. = "+minLen+"&nbsp;&nbsp;Max Len. = "+maxLen+"&nbsp;&nbsp;";
								tree += "Min Card. = "+min+"&nbsp;&nbsp;Max Card. = "+max+"&nbsp;&nbsp;Current Count = "+current+"</b></font>\n";
					}
					else
						if(temp != null )
							tree += "&nbsp;&nbsp;&nbsp;&nbsp;<font class='MessageAttrib'><b>Current Count = "+current+"</b></font>\n";

				}
				else{
				flag = 0;
				iterate = 0;
					if(temp != null && max != 0)
						tree += "&nbsp;&nbsp;&nbsp;&nbsp;<img align='middle' src="+CachedImages[0]+" onMouseOut=hidePopupMenu('menuT') onMouseDown=onMouseDownHandlerEd(event,'" + nodeVal[c].nodeName + "'," + nodeValue + ","+c+",'"+path+"','"+max+"','"+min+"','"+current+"','"+HexPath+"','"+type+"');setNodeValues('"+array1+"',"+array1+",'"+array3+"','"+array4+"','"+array5+"','"+array6+"','"+array7+"') >";
					tree += "&nbsp;&nbsp;<font class='dark'><b>" + nodeVal[c].nodeName + "</b></font>";
					if(min != null && max != null && max != 0)
					if(temp != null && temp == nodeVal[c]){
								tree += "&nbsp;&nbsp;&nbsp;&nbsp;<font class='MessageAttrib'><b>";
								if(type != null)
									tree += "Type = "+type+"&nbsp;&nbsp;"; 
								if(minLen != null && maxLen != null)
									tree += "Min Len. = "+minLen+"&nbsp;&nbsp;Max Len. = "+maxLen+"&nbsp;&nbsp;";
								tree += "Min Card. = "+min+"&nbsp;&nbsp;Max Card. = "+max+"&nbsp;&nbsp;Current Count = "+current+"</b></font>\n";
					}else{
						if(temp != null)
							tree += "&nbsp;&nbsp;&nbsp;&nbsp;<font class='MessageAttrib'><b>Current Count = "+current+"</b></font>\n";
					}
					if(nodeVal[c].childNodes.length != 0 && (nodeVal[c].childNodes[0].nodeType != 3 || nodeVal[c].childNodes[0].nodeType != 4) && nodeVal[c].childNodes[0].nodeName == 'Type'){
						if(nodeVal[c].childNodes.length > 2)
							textMaxLength = nodeVal[c].childNodes[2].childNodes[0].nodeValue;
						while(nodeVal[c].childNodes.length != 0){
							var obj = nodeVal[c].childNodes[0];
							nodeVal[c].removeChild(obj);
						}

						var theData ='';
						txtNode = AuxXMLObj.createTextNode(theData);
						nodeVal[c].appendChild(txtNode);
						tree += "<br/>";
						for(i=0;i<iteration;i++){
							tree += '<img src='+CachedImages[3]+' />';
						}
						tree += "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type = text size = '40' maxlength = '"+textMaxLength+"' ";
						if(checkReadOnlyOption()){
								tree += " disabled ";
						}
						tree += "onKeyUp='"+nodeValue+"["+c+"].childNodes[0].nodeValue=this.value' onMouseOut='"+nodeValue+"["+c+"].childNodes[0].nodeValue=this.value'></b></font>";
						flag = 1;
					}
				}


				if(nodeVal[c].attributes != null && nodeVal[c].attributes.length != 0){
					for(attributes=0; attributes< nodeVal[c].attributes.length;attributes++){
						if(nodeVal[c].attributes[attributes].nodeName != "kxyType" && nodeVal[c].attributes[attributes].nodeName != "maxCard" && nodeVal[c].attributes[attributes].nodeName != "minCard" && nodeVal[c].attributes[attributes].nodeName != "maxLen" && nodeVal[c].attributes[attributes].nodeName != "minLen" && nodeVal[c].attributes[attributes].nodeName != "KXY_TYPE")
						{
							tree += "<font class='Attribute'><b>&nbsp;&nbsp;"+nodeVal[c].attributes[attributes].nodeName+" = </b></font>";
							tree += "&nbsp;&nbsp;<input type ='text' size='20' value =\""+checkQuotes(nodeVal[c].attributes.item(attributes).nodeValue)+"\" ";
							if(checkReadOnlyOption()){
									tree += " disabled ";
							}
							tree += " onKeyUp='"+nodeValue+"["+c+"].attributes.item("+attributes+").nodeValue=this.value' onMouseOut='"+nodeValue+"["+c+"].attributes.item("+attributes+").nodeValue=this.value' >";
						}
					}
				}

				if(nodeVal[c].childNodes.length == 1 && (nodeVal[c].childNodes[0].nodeType == 3 || nodeVal[c].childNodes[0].nodeType == 4 ) && flag != 1){
					tree += "<br/>";
					for(i=0;i<iteration;i++){
							tree += '<img src='+CachedImages[3]+' />';
					}

					var temp = nodeVal[c].childNodes[0].nodeValue;
					if(temp.length > 40)
					{
						tree += "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<textarea cols = 40 rows = 4 ";
						if(readOnly)
							tree += " disabled ";
						tree += " onKeyUp='"+nodeValue+"["+c+"].childNodes[0].nodeValue=this.value' onMouseOut='"+nodeValue+"["+c+"].childNodes[0].nodeValue=this.value' >";
						tree += temp + "</textarea><br/>";
					}
					else
					{
						tree += "<font size = '2' class='dark'><b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type = text size = '40' value = \"" + checkQuotes(nodeVal[c].childNodes[0].nodeValue) + "\" ";
						if(checkReadOnlyOption()){
								tree += " disabled ";
						}
						tree += " onKeyUp='"+nodeValue+"["+c+"].childNodes[0].nodeValue=this.value' onMouseOut='"+nodeValue+"["+c+"].childNodes[0].nodeValue=this.value' ></b></font>";
					}
				}

				if(nodeVal[c].childNodes.length == 0 && nodeVal[c].nodeType == 1)
				{
					tree += "<br/>";
					for(i=0;i<iteration;i++)
							tree += '<img src='+CachedImages[3]+' />';

					var theData ='';
					txtNode = AuxXMLObj.createTextNode(theData);
					nodeVal[c].appendChild(txtNode);

					tree += "<font size = '2' class='dark'><b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type = text size = '40' ";

					if(checkReadOnlyOption())
							tree += " disabled ";

					tree += " onKeyUp='"+nodeValue+"["+c+"].childNodes[0].nodeValue=this.value' onMouseOut='"+nodeValue+"["+c+"].childNodes[0].nodeValue=this.value'></b></font>";
				}



				tree += "<br/><div id='treeSub" + divVal + "."+ c + "'>";

			 	if(iterate == 1)
			  	{
					var divS;
					var cValS;
					var iterS;
					var parentPathS;
					var TestFlagS;
					var hexPATHS;
					tree += showAllProperties(nodeValue+'', nodeS ,divS,cValS,iterS,parentPathS,TestFlagS,hexPATHS);
			  	}
				tree += "</div>";
			}
		}
	}
	return tree;

/////////////////////////////////////////////////////////////////////////////////////////////////////////


}


function subNodes(nodeString,nodeVal,divVal,cVal,iter,parentPath,TestFlag,hexPATH)
{
	HexIndex = new Array();

	var array1 = nodeString;
	var array2 = nodeVal;
	var array3 = divVal;
	var array4 = cVal;
	var array5 = iter;
	var array6 = parentPath;
	var array7 = hexPATH;
	var tree = "";

	if(cVal.length != 0)
	{
		nodeValue = nodeString + "[" + cVal + "].childNodes";
		nodeVal = nodeVal(cVal);
	}
	else
	{
		nodeValue = nodeString + ".childNodes";
		nodeVal = nodeVal;
	}
	var parent = nodeVal;

	if(document.getElementById('treeSub' + divVal).innerHTML != "" && TestFlag == ""){

		document.getElementById('treeSub' + divVal).innerHTML = "";
		document.getElementById('treeSub' + divVal).style.display = "none";
	}
	else{
		var textMaxLength;
		iter = parseInt(iter);
		iteration = iter + 1;
		nodeVal = nodeVal.childNodes;
		for(var c = 0; c != nodeVal.length; c++)
		{
		  	if((nodeVal[c].nodeType == 3 || nodeVal[c].nodeType == 4) && rtrim(ltrim(nodeVal[c].nodeValue)).length != 0){

			 }
		  	else{
				if(hexPATH != "" || hexPATH != null)
					HexPath = hexPATH ;


				if(HexIndex[nodeVal[c].nodeName] == null)
					HexIndex[nodeVal[c].nodeName] = 0;
				else
					HexIndex[nodeVal[c].nodeName] += 1;

				if(nodeVal[c].nodeName == rootName)
				{

					path = parentPath ;
					var auxPath = '//Body/Properties'+path;
						var max = 0;
						var min = 0;
						//var temp = "";

				}
				else
				{
					path = parentPath + "/" + nodeVal[c].nodeName;

					if(message.length != 0)
						var auxPath = '//Body/Properties'+path;
					else
						var auxPath = path;	
						
					if(HexPath != "")
						HexPath += "."+ nodeVal[c].nodeName;
					else
						HexPath = nodeVal[c].nodeName;

					var max = MaxCard(AuxXMLObj,auxPath);
					var min = MinCard(AuxXMLObj,auxPath);
					var maxLen = MaxLength(AuxXMLObj,auxPath);
					var minLen = MinLength(AuxXMLObj,auxPath);
					var type = getTypeAttribute(AuxXMLObj,auxPath);
					
					if(message.length != 0)
						var temp = getXMLTag("/*/*/Message[Header/KXY/ConnId="+con+"]/Body"+path,XMLDOMobj);
					else
						var temp = getXMLTag(path,XMLDOMobj);
						
					if(browser == "NS")
						temp = temp.iterateNext();
				}

				if(min != max)
					HexPath += "["+ HexIndex[nodeVal[c].nodeName] + "]";


				var count = parent.childNodes.length;
				current = 0;
				for(i=0;i<count;i++){
					if(parent.childNodes[i].nodeName == nodeVal[c].nodeName)
						current = current + 1;
				}

				for(i=0;i<iteration;i++)
					tree += '<img src='+CachedImages[3]+' />';

			if(kxySystemType != "" && (nodeVal[c].nodeName == "ValueData" || nodeVal[c].nodeName == "Message" || nodeVal[c].nodeName == "MessageData"))
			{
				if(parentPath == "/")
					var pathNested = parentPath + "*[" + c + "]";
				else
					var pathNested = parentPath + "/*[" + c + "]";
				tree += "&nbsp;&nbsp;<a href='#' class='list' onClick=openNestedEditor('"+pathNested+"',"+ nodeString +",'"+cVal+"',"+c+",'"+HexPath+"') ><font class='dark'><b>" + nodeVal[c].nodeName + "</b></font></a><br/>";
			}
			else
			{
		
				var valid = 0;
				if(browser == "NS"){
					if(nodeVal[c].childNodes.length > 1)
						valid = 1;
				}
				else{
					if(nodeVal[c].childNodes.length != 0)
						valid = 1;

					if(nodeVal[c].childNodes.length == 1 && (nodeVal[c].childNodes[0].nodeType == 3 || nodeVal[c].childNodes[0].nodeType == 4))
						valid = 0;
				}

				if(valid == 1 ){
					tree += '<img src='+CachedImages[1]+' name= "img'+divVal+'.'+c+'" height=12 width=12 onClick=subNodes("' + nodeValue + '",' + nodeValue + ',"' + divVal + '.'+c + '",' + c + ','+iteration+',"'+path+'","","'+HexPath+'");>';
					if(temp != null && max != 0)
						tree += "<img align='middle' src="+CachedImages[0]+" onMouseOut=hidePopupMenu('menuT') onMouseDown=onMouseDownHandlerEd(event,'" + nodeVal(c).nodeName + "'," + nodeValue + ","+c+",'"+path+"','"+max+"','"+min+"','"+current+"','"+HexPath+"','"+type+"');setNodeValues('"+array1+"',"+array1+",'"+array3+"','"+array4+"',"+array5+",'"+array6+"','"+array7+"') >";
					else
						tree += "&nbsp;&nbsp;";
					tree += '<font class="dark"><b>' + nodeVal(c).nodeName + '</b></font>';

					if(min != null && max != null && max != 0)
					if(temp != null && temp == nodeVal[c]){
								tree += "&nbsp;&nbsp;&nbsp;&nbsp;<font class='MessageAttrib'><b>";
								if(type != null)
									tree += "Type = "+type+"&nbsp;&nbsp;"; 
								if(minLen != null && maxLen != null)
									tree += "Min Len. = "+minLen+"&nbsp;&nbsp;Max Len. = "+maxLen+"&nbsp;&nbsp;";
								tree += "Min Card. = "+min+"&nbsp;&nbsp;Max Card. = "+max+"&nbsp;&nbsp;Current Count = "+current+"</b></font>";
					}
					else
					if(temp != null)
							tree += "&nbsp;&nbsp;&nbsp;&nbsp;<font class='MessageAttrib'><b>Current Count = "+current+"</b></font>";

				}
				else{
					flag = 0;
					if(temp != null && max != 0)
						tree += "&nbsp;&nbsp;&nbsp;&nbsp;<img align='middle' src="+CachedImages[0]+" onMouseOut=hidePopupMenu('menuT') onMouseDown=onMouseDownHandlerEd(event,'" + nodeVal(c).nodeName + "'," + nodeValue + ","+c+",'"+path+"','"+max+"','"+min+"','"+current+"','"+HexPath+"','"+type+"');setNodeValues('"+array1+"',"+array1+",'"+array3+"','"+array4+"','"+array5+"','"+array6+"','"+array7+"') >";
					tree += "&nbsp;&nbsp;<font class='dark'><b>" + nodeVal(c).nodeName + "</b></font>";
					if(min != null && max != null && max != 0)
					if(temp != null && temp == nodeVal[c]){
								tree += "&nbsp;&nbsp;&nbsp;&nbsp;<font class='MessageAttrib'><b>";
								if(type != null)
									tree += "Type = "+type+"&nbsp;&nbsp;"; 
								if(minLen != null && maxLen != null)
									tree += "Min Len. = "+minLen+"&nbsp;&nbsp;Max Len. = "+maxLen+"&nbsp;&nbsp;";
								tree += "Min Card. = "+min+"&nbsp;&nbsp;Max Card. = "+max+"&nbsp;&nbsp;Current Count = "+current+"</b></font>";
					}else{
						if(temp != null)
							tree += "&nbsp;&nbsp;&nbsp;&nbsp;<font class='MessageAttrib'><b>Current Count = "+current+"</b></font>";
					}
					if(nodeVal(c).childNodes.length != 0 && (nodeVal(c).childNodes(0).nodeType != 3 || nodeVal(c).childNodes(0).nodeType != 4) && nodeVal[c].childNodes[0].nodeName == 'Type'){
						if(nodeVal[c].childNodes.length > 2)
							textMaxLength = nodeVal[c].childNodes[2].childNodes[0].nodeValue;
						while(nodeVal[c].childNodes.length != 0){
							var obj = nodeVal[c].childNodes[0];
							nodeVal(c).removeChild(obj);
						}

						var theData ='';
						txtNode = AuxXMLObj.createTextNode(theData);
						nodeVal(c).appendChild(txtNode);
						tree += "<br/>";
						for(i=0;i<iteration;i++){
							tree += '<img src='+CachedImages[3]+' />';
						}
						tree += "<input type = text size = '40' maxlength = '"+textMaxLength+"' ";
						if(checkReadOnlyOption()){
							tree += " disabled ";
						}
						tree += " onKeyUp='"+nodeValue+"["+c+"].childNodes[0].nodeValue=this.value' onMouseOut='"+nodeValue+"["+c+"].childNodes[0].nodeValue=this.value'></b></font>";
						flag = 1;
					}
				}


				if(nodeVal[c].attributes != null &&  nodeVal(c).attributes.length != 0){
						for(attributes=0; attributes< nodeVal(c).attributes.length;attributes++){
							if(nodeVal[c].attributes[attributes].nodeName != "kxyType" && nodeVal[c].attributes[attributes].nodeName != "maxCard" && nodeVal[c].attributes[attributes].nodeName != "minCard" && nodeVal[c].attributes[attributes].nodeName != "maxLen" && nodeVal[c].attributes[attributes].nodeName != "minLen" && nodeVal[c].attributes[attributes].nodeName != "KXY_TYPE")
								{
								tree += "<font class='Attribute'><b>&nbsp;&nbsp;"+nodeVal(c).attributes[attributes].nodeName+" = </b></font>";
								tree += "&nbsp;&nbsp;<input type ='text' size='20' value =\""+checkQuotes(nodeVal[c].attributes.item(attributes).nodeValue)+"\" ";
								if(checkReadOnlyOption()){
										tree += " disabled ";
								}
								tree += " onKeyUp='"+nodeValue+"["+c+"].attributes.item("+attributes+").nodeValue=this.value' onMouseOut='"+nodeValue+"["+c+"].attributes.item("+attributes+").nodeValue=this.value' >";
							}
						}
				}

				if(nodeVal(c).childNodes.length != 0 && (nodeVal(c).childNodes(0).nodeType == 3 || nodeVal(c).childNodes(0).nodeType == 4) && flag != 1)
				{
					tree += "<br/>";
					for(i=0;i<iteration;i++){
							tree += '<img src='+CachedImages[3]+' />';
					}

					var temp = nodeVal[c].childNodes[0].nodeValue;
					if(temp.length > 40)
					{
						tree += "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<textarea cols = 40 rows = 4 ";
						if(readOnly)
							tree += " disabled ";
						tree += " onKeyUp='"+nodeValue+"["+c+"].childNodes[0].nodeValue=this.value' onMouseOut='"+nodeValue+"["+c+"].childNodes[0].nodeValue=this.value'>";
						tree += temp + "</textarea><br/>";
					}
					else
					{
						tree += "<font size = '2' class='dark'><b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type = text size = '40' value = \"" + checkQuotes(nodeVal[c].childNodes[0].nodeValue) + "\" ";
						if(checkReadOnlyOption()){
							tree += " disabled ";
						}
						tree += " onKeyUp='"+nodeValue+"["+c+"].childNodes[0].nodeValue=this.value' onMouseOut='"+nodeValue+"["+c+"].childNodes[0].nodeValue=this.value'></b></font>";
					}
				}
				if(nodeVal(c).childNodes.length == 0 && nodeVal[c].nodeType == 1)
				{
					tree += "<br/>";
					for(i=0;i<iteration;i++)
							tree += '<img src='+CachedImages[3]+' />';

					var theData ='';

					txtNode = AuxXMLObj.createTextNode(theData);
					nodeVal[c].appendChild(txtNode);

					tree += "<font size = '2' class='dark'><b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type = text size = '40' ";
					 if(checkReadOnlyOption())
						tree += " disabled ";

					tree += " onKeyUp='"+nodeValue+"["+c+"].childNodes[0].nodeValue=this.value' onMouseOut='"+nodeValue+"["+c+"].childNodes[0].nodeValue=this.value'></b></font>";
				}
			}

			tree += "<br/><div id='treeSub" + divVal +"."+ c + "'></div>";
		}

	}
	tree += "</div>";

	document.getElementById('treeSub' + divVal).innerHTML = tree;
	document.getElementById('treeSub' + divVal).style.display = "block";
  }
	expandNode(divVal);

}


function setNodeValues(a1,a2,a3,a4,a5,a6,a7){
arrayNode1 = a1;
arrayNode2 = a2;
arrayNode3 = a3;
arrayNode4 = a4;
arrayNode5 = a5;
arrayNode6 = a6;
arrayNode7 = a7;

}


function onMouseDownHandlerEd(e,selectedNode,node,index,pathPassed,maxPass,minPass,currentPass,hexpath,type) {
	if(browser != "NS")
	{
		var e = event;
		if(e.button == 1 || e.button == 2 || e.button == 3)
			showAddRemMenu(e,selectedNode,node,index,pathPassed,maxPass,minPass,currentPass,hexpath,type)

	}
	if(browser == "NS" && (e.which==1 || e.which==3 || e.which==2))
	{
     		showAddRemMenu(e,selectedNode,node,index,pathPassed,maxPass,minPass,currentPass,hexpath,type);
    	}
}



function showAddRemMenu(e,selectedNode,node,index,pathPassed,maxPass,minPass,currentPass,hexpath,type)
{

//selectedXML = getXMLTag(pathPassed,XMLDOMobj);
nodeSelected = selectedNode;
pathSelected = pathPassed;
maxSelected	= maxPass;
minSelected = minPass;
currentSelected = currentPass;
nodeSel = node[index];
hexPathSelected = hexpath;
if(hexPathSelected.substring(0,1) == ".")
	hexPathSelected = hexPathSelected.substring(1,hexPathSelected.length);
selectedConID = con;

    var x=y=0;
    if (e != '') {
        x = e.screenX;
        y = e.screenY;
    }
    if(browser == "NS")
    {
	x = x - self.screenX + 5;
	y = y - self.screenY - 20;
    }
    else
    {
	x = x - self.screenLeft + 10;
	y = y - self.screenTop + 7;
    }

showPopupMenu('menuT',x,y,'','',type);

}




function addNodes()
{

	if(maxSelected <= currentSelected){
		M_alert("This node cannot be added as:<ul><li>Minimum cardinality is "+minSelected+" </li><li> Maximum cardinality is " +maxSelected+ " </li><li> Current Count of the node is "+currentSelected+"</li></ul>");

	}
	else{
		NodetoClone = getXMLTag(pathSelected,AuxXMLObj);
		if(browser == "NS")
			NodetoClone = NodetoClone.iterateNext();

 		tempNode =  NodetoClone.cloneNode(true);

		nodeSel.parentNode.appendChild(tempNode);

		subNodes(arrayNode1,arrayNode2,arrayNode3,arrayNode4,arrayNode5,arrayNode6,1,arrayNode7);
		hidePopupMenu("");
	}
}



function removeNodes()
{
	if(currentSelected <= minSelected)
		M_alert("This node cannot be removed as:<ul><li>Minimum cardinality is "+minSelected+" </li><li> Maximum cardinality is " +maxSelected+ " </li><li> Current Count of the node is "+currentSelected+"</li></ul>");
	//else
	//if(currentSelected == 1)
		//M_alert("This node cannot be removed as the <ul><li>Current Count of the node is "+currentSelected+"</li></ul>");	
	else
	{
		nodeSel.parentNode.removeChild(nodeSel);

		subNodes(arrayNode1,arrayNode2,arrayNode3,arrayNode4,arrayNode5,arrayNode6,1,arrayNode7);
		hidePopupMenu("");
	}
}


function displayMenu()
{
	path = '/';
	var tree = "<table width='80%' border='1' cellspacing='0'><tr><td align='left'>";
	tree += "<DIV id='bodyEdit' STYLE='height:"+showHeight+";width:600;overflow:auto' class='treeView' >";
	tree += "<table width='100%' ><tr><td valign='top' ><img align='left' src='images/expandAll.gif' name='show' onmouseover=onMouseOverImage(1) onmouseout=onMouseOverImage(2) onClick='setCursorTable(44)' TABINDEX = 5 onFocus='fieldOnFocus = 5;onmouseover()' onBlur='onmouseout();fieldOnFocus = 1' /></td></tr></table>";
	tree += "<table width='100%' height='90%' border='0' cellpadding='5' cellspacing='0'>";

		rootI = 1;

	tree += "<tr><td valign='top'  nowrap>";

	if(message.length != 0)
	{
		if(node3.length != 0 && node3(0).nodeType != 3)
			tree += "<img src="+CachedImages[1]+" name ='img1' height=12 width=12 onClick = subNodes('node3',node3,'1',1,1,'/','','')>&nbsp;&nbsp;<font class='dark'><b>" + node3(1).nodeName + "</b></font>";
		else
			tree += "<font class='dark'><b>" + node3(1).nodeName + "</b></font>";
	}
	else
	{
		if(node3.nodeType != 3)
			tree += "<img src="+CachedImages[1]+" name ='img1' height=12 width=12 onClick = subNodes('node3',node3,'1','',1,'/','','')>&nbsp;&nbsp;<font class='dark'><b>" + node3.nodeName + "</b></font>";
		else
			tree += "<font class='dark'><b>" + node3.nodeName + "</b></font>";
	}
	tree += "<div id='treeSub1'></div>";
	tree += "</td></tr>";
	tree += "</table>";
	tree += "</DIV></td></tr></table>";

	document.getElementById('treeSub0').innerHTML = tree;
	window.focus();
}



function expandNode(nodeDiv){


if(document.getElementById('treeSub' + nodeDiv).innerHTML == "")
{
	document.getElementById('img' + nodeDiv).src=CachedImages[1];
	iteration -= 1;
}
else
	document.getElementById('img' + nodeDiv).src=CachedImages[2];
}



function updateMessageReq(paramsForForm, dialogName)
{
	    var hasProperties = 0;
		var type = paramsForForm[5];
		
		checkForMDRXMLMessage(0);
		
		if(type == "MDR_XML" && paramsForForm[1] != null )
		{
			var node = getXMLTag("//Properties",paramsForForm[1]);
			if(browser == "NS")
				node = node.iterateNext();

			if(node.childNodes.length != 0)
				hasProperties = 1;
		}
//cjj, fix the mistake of no response when editting and saving the formatted messages.
//type = "STANDALONE";
//cjj end
		if(type == "RAW_TEXT" || type == "RAW_HEXA" || type == "STANDALONE" || (type == "MDR_XML"  && hasProperties == 0) )
		{
			var changedType  = kxyType; 

			var changeFormat = 0;
			
			if(body_type == "Map" || body_type == "Stream")
			{
				var StringTextArea = returnXML;		
			}
			else
			if(changedType != "RAW_TEXT" && changedType != "RAW_HEXA")
			{
			
				var newObj;
				 if (document.implementation && document.implementation.createDocument)
				 {
				   // netscape 6.x+ support


					  newObj = document.implementation.createDocument("","", null);
				 }
				 else if (window.ActiveXObject)
				 {
				   // ie 5.x+ support
					  newObj = new ActiveXObject("Microsoft.XMLDOM");

				 }
				else
				 {
				   M_alert(err_327);
				   return;
				 }
				var StringTextArea = returnXML;
				newObj.loadXML(returnXML);
				
				var xmlTag = "";
				var indexXML = 0;
				

				while(newObj.childNodes[indexXML].nodeType != 1 && ( newObj.childNodes[indexXML].nodeType == 7 || newObj.childNodes[indexXML].nodeType == 8))
				{
					if(newObj.childNodes != null && newObj.childNodes[indexXML] != null && ( newObj.childNodes[indexXML].nodeType == 7 || newObj.childNodes[indexXML].nodeType == 8))
					{
						xmlTag += (newObj.childNodes[indexXML]).xml;
						StringTextArea = (newObj.childNodes[indexXML+1]).xml;
					}
					indexXML++;
				}
			}
			
			
			var XMLPATH = "//Message[Header/KXY/ConnId="+con+"]/Header";

			var updatedXMLObj = getXMLTag(XMLPATH,XMLDOMobj);
			
			if(changedType != type)
			for(i=0; i<updatedXMLObj.firstChild.childNodes.length; i++)
			{
				if(updatedXMLObj.firstChild.childNodes[i].nodeName == "KXY_TYPE" && updatedXMLObj.firstChild.childNodes[i].childNodes[0].nodeValue != changedType){
					if(updatedXMLObj.firstChild.childNodes[i].childNodes[0].nodeValue == "MDR_XML" && (changedType == "STANDALONE"||changedType == "MDR_XML"))
						break;
					else{
						updatedXMLObj.firstChild.childNodes[i].childNodes[0].nodeValue = changedType;
						changeFormat = 1;
						break;
					}
				}
			}
			

			if(changeFormat == 1)
			{
				for(var i=0; i<updatedXMLObj.firstChild.childNodes.length; i++)
				{
				    var nameN= updatedXMLObj.firstChild.childNodes[i];
					if(nameN.nodeName == "format")
					{
						if(nameN.childNodes.length != 0 && nameN.childNodes[0] != null)
							nameN.childNodes[0].nodeValue = "";

					}
					else
					if(nameN.nodeName == "pFormat"){
						if(nameN.childNodes.length != 0 && nameN.childNodes[0] != null)
							nameN.childNodes[0].nodeValue = "";

					}
				}		

			}
		
			var paramStringHeader = updatedXMLObj.xml;
			
			if(dialogName == 'kxyEdJMF')
			{
				var paramStringProp = "";
				XMLPATH = "//Message[Header/KXY/ConnId="+con+"]/Properties";
				updatedXMLObj	= getXMLTag(XMLPATH,XMLDOMobj);
				if(updatedXMLObj != null)
					paramStringProp = updatedXMLObj.xml;					
			}

			
			if(changedType == "RAW_TEXT" || changedType == "RAW_HEXA")
			{

					returnObj = "<Message>"+ paramStringHeader + "<Body>";
					
					var len = returnXML.length;
					var flag = 0;
					var index = returnXML.indexOf("]]>");
					while(index != -1)
					{
						flag = flag+1;
						returnObj += "<Bytes"+flag+"><![CDATA["+returnXML.substring(0, index + 1)+"]]></Bytes"+flag+">";
						returnXML = returnXML.substring(index+1,returnXML.length);
						index = returnXML.indexOf("]]>");
					}

					if(flag == 0)
						returnObj += "<Bytes><![CDATA["+returnXML+"]]></Bytes></Body>";
					else
					{
						flag = flag + 1;
						returnObj += "<Bytes"+flag+"><![CDATA["+returnXML+"]]></Bytes"+flag+"></Body>";
					}
				
 	  		
					if(dialogName == 'kxyEdJMF')
						returnObj += paramStringProp;
					returnObj += "</Message>";
			}else{

					returnObj = "<Message>"+ paramStringHeader + "<Body>";
					if(xmlTag != "")
						returnObj += "<![CDATA["+xmlTag+"]]>";
					returnObj += StringTextArea+"</Body>";
					if(dialogName == 'kxyEdJMF')
						returnObj += paramStringProp;
					returnObj += "</Message>";
			}

			headerUpdate = 1;
			M_update(returnObj,changedType);
		}
		else{

			var XMLPATH = "//Message[Header/KXY/ConnId="+con+"]/Body";
			var updatedXMLObj = getXMLTag(XMLPATH,XMLDOMobj);


			var paramString="";

			if(type == "MDR_XML")
			{
				paramString = "<Body>";
				for(i=0; i<updatedXMLObj.childNodes[0].childNodes.length;i++)
				{
					paramString += updatedXMLObj.childNodes[0].childNodes[i].xml;
				}
				paramString += "</Body>"; 
			}
			else{
					paramString += updatedXMLObj.xml;
			}

			XMLPATH = "//Message[Header/KXY/ConnId="+con+"]/Header";
			updatedXMLObj	= getXMLTag(XMLPATH,XMLDOMobj);

			var paramStringHeader = updatedXMLObj.xml;

			if(dialogName == 'kxyEdJMF')
			{
				var paramStringProp = "<Properties></Properties>";
				XMLPATH = "//Message[Header/KXY/ConnId="+con+"]/Properties";
				updatedXMLObj	= getXMLTag(XMLPATH,XMLDOMobj);

				if(updatedXMLObj != null)
					paramStringProp = updatedXMLObj.xml;

				returnObj = paramStringHeader + paramString + paramStringProp;
			}
			else
				returnObj = paramStringHeader + paramString;
//alert("returnObj "+returnObj);
			M_update(returnObj,type);
		}
}





function checkForMDRXMLMessage(flag)
{
	var typeM = "MessageData";
	xmlPathMDR = "/*/*/Message[Header/KXY/ConnId="+con+"]/Body/";

	if(getXMLTag(xmlPathMDR + "/" + typeM,XMLobj) != null)
	{
		xmlPathMDR = xmlPathMDR + "/" + typeM;

		pathMDR = typeM;
		fixMDRXMLMessage(typeM,flag);
	}
}

var pathMDR;
var xmlPathMDR;
var rootObj;

function fixMDRXMLMessage(typeM, flag)
{
	var node = getXMLTag(xmlPathMDR,XMLobj);

	if(node != null)
	{
		var type = node.getAttribute("kxyType")

		if(type != null && type == "MDR_XML")
		{
			if(flag == 0)
			{
				rootObj = node.cloneNode("true");

				if(node.childNodes.length != 0)
				{
					var xmlNode = getXMLTag(xmlPathMDR+"/*[0]", XMLobj);
					var tempC = xmlNode.childNodes.length;
					for(var i = 0; i < tempC; i++)
					{
						node.appendChild(xmlNode.childNodes[0]);
					}
					var obj = node.firstChild;
					node.removeChild(obj);
				}
			}
			else
			{
				if(node.childNodes.length != 0)
				{
					var tempC = node.childNodes.length;
					for(var i = 0; i < tempC; i++)
					{
						node.removeChild(node.firstChild);
					}

					var tempC = rootObj.childNodes.length;
					for(var i = 0; i < tempC; i++)
					{
						node.appendChild(rootObj.childNodes[0]);
					}
				}			
			}
		}
		else
		{
			xmlPathMDR = xmlPathMDR + "/" + typeM;

			pathMDR = pathMDR + "."+ typeM;

			fixMDRXMLMessage(typeM,flag);
		}
	}
}
