/*
######################################################################

             IBM Confidential
             
             OCO Source Materials
             
             (C) Copyright IBM Corp. 2007
             
             The source code for this program is not
             published or otherwise divested of its
             trade secrets, irrespective of what has
             been deposited with the U.S Government
             Copyright Office.

######################################################################
#$Id: kxyErrLi.js,v 1.1.2.3 2009/08/20 09:19:31 cjj Exp $#
######################################################################
# Copyright 1999-2003, Candle Corporation, a California corporation.  
# All rights reserved. International copyright secured.
#
# This material is proprietary to Candle Corporation and is not to be
# reproduced, used, or disclosed except in accordance with program
# licenses or upon written authorization of Candle Corporation.
#
#######################################################################*/

/*
######################################################################
The error messages that belong to the tree view (of queue managers, 
client connection, jms cconnection) and its functionality are listed 
in kxyErrTr.js and have format err_0..

The error message that belong to the list of queues and its functionality
are listed in kxyErrLi.js and have format err_1..

The error message that belong to the message window are listed in 
kxyErrTa.js and have format err_2..

The error message that donot belong to any particular window are listed 
in kxyErrGn.js and have format err_3..
#######################################################################*/

err_101 = "Enter the name for the queue.";
err_102 = "A queue name can have only letters, digits,'.', '/', '%' and '_'.";
err_103 = "A queue name cannot contain spaces.";
err_104 = "The queue description should be limited to 64 characters.";//not used anymore
err_105 = "Enter a whole number between 0 and 640000 for 'Max. Queue Depth' field.";
err_106 = "Enter a whole number between 0 and 100000000 for 'Max. Message Length field.";
err_107 = "Enter a whole number between 0 and 999999999 for 'Retention Interval' field.";
err_108 = "Enter a whole number between 0 and 999999999 for 'Backout Threshold' field.";
err_109 = "Enter a whole number between 0 and 999999999 for 'Trigger Depth' field.";
err_110 = "The trigger data should be limited to 64 characters for 'Trigger Data' field.";
err_111 = "Enter a whole number between 0 and 100 for 'Upper Queue Depth Threshold' field.";
err_112 = "Enter a whole number between 0 and 100 for 'Lower Queue Depth Threshold' field.";
err_113 = "Enter a whole number between 0 and 999999999 for 'Queue Service Interval' field.";
err_114 = "Remote queue manager name should be limited to 48 characters.";
err_115 = "Count field cannot be left empty.";
err_116 = "Enter a positive value for count.";
err_117 = "Enter a whole number for count.";
err_118 = "Enter a number for 'Max. No. of messages' field.";
err_119 = "Enter a number other than '0' for count.";
err_120 = "Max. messages per display cannot be more than ";
err_121 = "Please enter Base Queue Name in 'Other Properties' dialog.";
err_122 = "A queue name can start with only letters, digits, '.', '/', '%' and '_'."
err_123 = "Enter a whole number between 1 and ";
//cjj, the error messages that belong to the list of queues when inputting the content of EditMsgExBytes in "Open Queue" dialog window
err_124 = "Max Edit Message Size field cannot be left empty.";
err_125 = "Enter a number for 'Max Edit Message Size' field.";
err_126 = "Enter a whole number for Max Edit Message Size.";
err_127 = "Enter a positive value for Max Edit Message Size.";
err_128 = "Max value of 'Max Edit Message Size' cannot be more than ";
//cjj end