/*
######################################################################

             IBM Confidential
             
             OCO Source Materials
             
             (C) Copyright IBM Corp. 2007
             
             The source code for this program is not
             published or otherwise divested of its
             trade secrets, irrespective of what has
             been deposited with the U.S Government
             Copyright Office.

######################################################################
#$Id: kxyErrTa.js,v 1.12 2004/05/04 21:24:51 rbais Exp $#
######################################################################
# Copyright 1999-2003, Candle Corporation, a California corporation.  
# All rights reserved. International copyright secured.
#
# This material is proprietary to Candle Corporation and is not to be
# reproduced, used, or disclosed except in accordance with program
# licenses or upon written authorization of Candle Corporation.
#
#######################################################################*/

/*
######################################################################
The error messages that belong to the tree view (of queue managers, 
client connection, jms cconnection) and its functionality are listed 
in kxyErrTr.js and have format err_0..

The error message that belong to the list of queues and its functionality
are listed in kxyErrLi.js and have format err_1..

The error message that belong to the message window are listed in 
kxyErrTa.js and have format err_2..

The error message that donot belong to any particular window are listed 
in kxyErrGn.js and have format err_3..
#######################################################################*/

err_201 = "Enter a whole number greater than 0 for message number.";
err_202 = "Enter a whole number greater than 0 and not more than ";
err_203 = "Message number cannot be greater than total number of messages which is ";
err_204 = "Wrong XML in textarea.";
err_205 = "Please enter something in textarea.";
err_206 = "Enter a whole number for characterSet field in header.";
err_207 = "Header meta data not available.";
err_208 = "The queue has been opened as 'Read only'.";
err_209 = "Your browser does not support XML.";
err_210 = "Comments should be inside root tag in XML.";
err_211 = "Please enter a queue name.";
err_212 = "Please enter a queue manager's name.";
err_213 = "Please enter or select a name for the file.";
err_214 = "Error, refresh before editing.";
err_215 = "Error, refresh before deleting.";
err_216 = "Error, refresh before cutting.";
err_217 = "Error, refresh before copying.";
err_218 = "Error, refresh before doing another pasting.";
err_219 = "Enter a number other than '0' for count.";
err_220 = "Error, refresh before forwarding.";
err_221 = "Error, refresh before using find.";
err_222 = "Error, refresh before using replace.";
err_223 = "Enter name in text box.";
err_224 = "A node name cannot start with a number or '-' or any special characters.";
err_225 = "A node name can have only letters, digits, '-', '_' and '.'. Node name cannot start or end with ':'.";
err_226 = "A node name cannot have ' ' character.";
err_227 = "Select Do not use Message Formatting, or select an available format.";
err_228 = "A file name can have only letters, digits, '-' and '_'.";
err_229 = "Enter a name for the node.";
err_230 = "Enter a value for text node.";
err_231 = "Text node already exists. Change the data value in text box.";
err_232 = "Enter a name for the attribute.";
err_233 = "Cannot remove root node.";
err_234 = "Enter name for the attribute to be removed.";
err_235 = "Enter a name for the sibling.";
err_236 = "Cannot add sibling to root node.";
err_237 = "Message too big to expand all. Individual fields can be expanded as necessary.";
err_238 = "Error retrieving formats for creating message."; // This error message is in kxyErrTa.js also
err_239 = "Message has been created.";
err_240 = "Message create request could not be sent.";
err_241 = "Messages have been deleted successfully.";
err_242 = "Select messages to delete first";
err_243 = "Select only one message to edit.";
err_244 = "Select a message to edit.";
err_245 = "Error forming Hexa XML.";
err_246 = "Message has been updated successfully.";
err_247 = "Error passing the updated message.";
err_248 = "Messages have been copied to the clipboard successfully.";
err_249 = "Select messages to copy first.";
err_250 = "Messages have been cut to the clipboard successfully.";
err_251 = "Select messages to cut first.";
err_252 = "Message(s) have been pasted successfully.";
err_253 = "Select message(s) to delete.";
err_254 = "Select message(s) to forward.";
err_255 = "File loaded successfully.";
err_256 = "Messages unloaded successfully and deleted from this queue.";
err_257 = "Messages unloaded successfully.";
err_258 = "Transactions have been committed.";
err_259 = "Unable to commit, open the queue in transactional mode.";
err_260 = "Rollback finished successfully.";
err_261 = "Unable to rollback, open the queue in transactional mode.";
err_262 = "Please select a column first.";
err_263 = "Unable to replace.";
err_264 = "There are no messages to unload.";
err_265 = "Error retrieving attributes.";
err_266 = "A property name can start with only letters or '_' ";
err_267 = "A property name can have only letters, digits, '-' and '_'.";
err_268 = "A property name cannot have ' ' character.";
err_269 = "Please select a message type.";
err_270 = "Please select a message format.";
err_271 = "Close the Find window first.";
err_272 = "Close the Replace window first.";
err_273 = "The message buffer is full. Please Refresh.";
err_274 = "Invalid child name.";
err_275 = "Invalid sibling name.";
err_276 = "Invalid attribute name.";
err_277 = "The MQ format will be truncated to the first 8 characters.";
err_278 = 'Unable to display messages. Please try again by selecting "Ignore Message Formatting" in open queue dialog.';