/*
#$Id: kxyXML.js,v 1.1.2.3 2009/08/20 09:19:31 cjj Exp $#
######################################################################

             IBM Confidential
             
             OCO Source Materials
             
             (C) Copyright IBM Corp. 2005-2007
             
             The source code for this program is not
             published or otherwise divested of its
             trade secrets, irrespective of what has
             been deposited with the U.S Government
             Copyright Office.

######################################################################
######################################################################
# Copyright 1999-2003, Candle Corporation, a California corporation.  
# All rights reserved. International copyright secured.
#
# This material is proprietary to Candle Corporation and is not to be
# reproduced, used, or disclosed except in accordance with program
# licenses or upon written authorization of Candle Corporation.
#
#######################################################################*/


function XML_getXMLLogin(userid,password)
// returns the xml request to login
{
  var aux= '<?xml version="1.0"?><Request><Header><Operation>Login</Operation></Header>';
  if(userid)
  	aux += '<Body><UserId>'+userid+'</UserId><Password>'+password+'</Password></Body>';
  
  aux += '</Request>';
  if (debug_On==true)
	logReq("login",aux);
  return aux;
}


function XML_logout(handle)
{
  var aux= '<?xml version="1.0"?><Request><Header><Operation>Logout</Operation><Handle>'+handle+'</Handle></Header></Request>';
  if (debug_On==true)
	  logReq("logout",aux);
  return aux;
}


function getTag(xpathTag,xml)
// returns the value of the tag xpathtag from xml
{
	//alert("getTag");
  if (getBrowser()=="NS"){	
        var e=new XPathEvaluator();
	var result=e.evaluate(xpathTag,xml,null,XPathResult.STRING_TYPE,null);
	if (result.stringValue)
	        return result.stringValue;
	else
		return null;

 } else { 
   var result=xml.selectSingleNode(xpathTag);
   if (result!=null)
	return result.text;
   else
	return null;
 }
}

function getXMLTag(xpathTag,xml)
// returns an xml from the xml input, filtering with xpathTag
{
 if (getBrowser()=="NS"){	
  var e=new XPathEvaluator();
  var result=e.evaluate(xpathTag,xml,null,XPathResult.ORDERED_NODE_ITERATOR_TYPE,null);  

  return result;

 } else {
   var result=xml.selectSingleNode(xpathTag);
   return result;
}
}

function getNodes(xpath,xml)
{
 browser=getBrowser();
 if (browser=="NS"){	
  var e=new XPathEvaluator();
  var result=e.evaluate(xpath,xml,null,XPathResult.ORDERED_NODE_SNAPSHOT_TYPE,null);
  return result;
 }else {
   var result=xml.selectNodes(xpath);
   return result;
}
}

function XML_removeNodes(xpath,xml)
{
var i,top,aux;
var parent=getXMLTag(xpath,xml);
if (browser=="NS")
{
  var nod=parent.iterateNext();
  parent=nod;
  if (!parent)	
	parent=null;
}
if (parent!=null)
{
 aux=parent.childNodes;
 if (aux!=null)
 {
	 tope=aux.length;
	 for (i=0;i<tope;i++)
	 { 
	   aux=parent.childNodes[0];
	   parent.removeChild(aux);
	 }
 }
}
}


function getAttrib(xml,path,attrib)
{
  var node=getXMLTag(path,xml);
  if (browser=="NS")
  {
    var nod=node.iterateNext();
    node=nod;
    if (!node)	
	node=null;
  }
  if(node != null)
  	return node.getAttribute(attrib);
  else
  	return 0;
}

function count(xpath,xml)
{
 var subxml=getNodes(xpath,xml);
 if ((subxml)&&(subxml!=null))
 {
  if (browser=="NS")
	return subxml.snapshotLength;
  return subxml.length;
 }else return 0;
}

function addNode(xml1,value)
{
// this function should work for NS and IE
var node;
node=xml1.createTextNode(value);
xml1.appendChild(node);
return xml1;
}

function XML_addQueueProfile(newQueue,array_options)
{

 var newQueue="<Queue><Name><![CDATA["+newQueue+"]]></Name>";
var i,j;  
var OPENOP=OPENOPTIONS;

 for (i=1;i<=13;i++)
 {
   newQueue =newQueue + "<" +OPENOP[i-1]+">"+array_options[i]+"</"+OPENOP[i-1]+">";
  }
 j=15;
  if ((array_options[14]!='null')&&(array_options[14]!=0))
  {
	newQueue+="<RowFilter>";
	flt=0;
        for (p=0;p<array_options[14];p++)
		flt++;
	for (j=15;j<15+flt;j++)
		newQueue+="<Filter>"+array_options[j]+"</Filter>";
	newQueue+="</RowFilter>";
		
  }  
k=j+1;
  if ((array_options[j]!='null')&&(array_options[j]!=0))
  {
	newQueue+="<ColumnFilter>";
	flt=0;
        for (p=0;p<array_options[j];p++)
		flt++;
	for (k=j+1;k<=j+flt;k++)
		newQueue+="<Filter>"+array_options[k]+"</Filter>";
	newQueue+="</ColumnFilter>";
		
  }  
j=k+1;
  if ((array_options[k]!=null)&&(array_options[k]!=0))
  {
	newQueue+="<RowHeaderFilter>";
	flt=0;
        for (p=0;p<array_options[k];p++)
		flt++;
	for (j=k+1;j<=k+flt;j++)
		newQueue+="<Filter>"+array_options[j]+"</Filter>";
	newQueue+="</RowHeaderFilter>";
		
  }  
  if ((array_options[j]!='null')&&(array_options[j]!=0))
  {
	newQueue+="<ColumnHeaderFilter>";
	flt=0;
        for (p=0;p<array_options[j];p++)
		flt++;
	for (k=j+1;k<=j+flt;k++)
		newQueue+="<Filter>"+array_options[k]+"</Filter>";
	newQueue+="</ColumnHeaderFilter>";
  }
  //cjj, assemble the value "EditMsgExBytes" in order to write it into the user profile.xml file
  newQueue += "<EditMsgExBytes>" + array_options[array_options.length-3] + "</EditMsgExBytes>";
  //cjj end
  newQueue=newQueue+"</Queue>";
  return newQueue;
}


function XML_updateNodeProfile(queueName,node_name,node_array,value)
{
var node = node_name + node_array;
var path = "//"+QType;

  var userQueue = getXMLTag(path + "//Backend[Name='"+ActiveQmgr+"']/Queues/Queue[Name=\""+queueName+"\"]/"+node,userProfile,browser);
  var i,j;
  var xmlString = "<?xml version='1.0'?>";
  if (browser=="NS")
  {
  var nod=userQueue.iterateNext();
  userQueue=nod;
  if (!userQueue)	
	userQueue=null;
}
if (userQueue!=null)
{
	 if (userQueue.childNodes[0]!=null)
		userQueue.childNodes[0].nodeValue=value; 
	  else
	    {
		var aux=userProfile.createTextNode(value);
		userQueue.appendChild(aux);
		}
}else
{
	if(node == "FieldSize" || node == "FieldCount" || node == "EditMsgExBytes")
	{
		userQueue = getXMLTag(path +"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue[Name=\""+queueName+"\"]",userProfile,browser);
		var tempNode = userProfile.createElement(node);
		tempNode.appendChild(userProfile.createTextNode(value));
		userQueue.appendChild(tempNode);
	}
	else
	{
		l=node_name.length-7;
		aux=node_name.substr(0,l);

		userQueue = getXMLTag(path +"//Backend[Name='"+ActiveQmgr+"']/Queues/Queue[Name=\""+queueName+"\"]/"+aux,userProfile,browser);
		if (browser=="NS")
		{
		  var nod=userQueue.iterateNext();
		  userQueue=nod;
		  if (!userQueue)
			userQueue=null;
		}

		if (userQueue!=null)
		{
			if (browser!="NS")
				var aux=userProfile.createNode(1,"Filter","");
			else
				var aux=userProfile.createElement("Filter");
			var aux2=userProfile.createTextNode(value);
			aux.appendChild(aux2);
			userQueue.appendChild(aux);

		}else{

			if (browser!="NS")
				var aux=userProfile.createNode(1,aux,"");
			else
				var aux=userProfile.createElement(aux);
			if (browser!="NS")
				var aux2=userProfile.createNode(1,"Filter","");
			else
				var aux2=userProfile.createElement("Filter");

			var aux3=userProfile.createTextNode(value);
			aux2.appendChild(aux3);
			aux.appendChild(aux2);
			userQueue = getXMLTag(path + "//Backend[Name='"+ActiveQmgr+"']/Queues/Queue[Name=\""+queueName+"\"]",userProfile,browser);
			if (browser=="NS")
			{
			  var nod=userQueue.iterateNext();
			  userQueue=nod;
			  if (!userQueue)	
				userQueue=null;
			}
			if (userQueue!=null)
				userQueue.appendChild(aux);
		}
	}

    }
}

//********************************************************************************
//*********************					**************************
//********************* 	TREE FUNCTIONS		**************************
//*********************					**************************
//********************************************************************************


function XML_getXMLListR(type,handle)
// returns the xml request to list resources
{
  var aux='<?xml version="1.0"?><Request><Header><Operation>ListResources</Operation><Handle>'+handle+'</Handle></Header><Body><MessagingType>'+type+'</MessagingType></Body></Request>';
  if (debug_On==true)
	  logReq("ListResources",aux);
  return aux;
}

function XML_removeClient(handle,params)
// returns the xml request to remove a client connection
{
  var aux= '<?xml version="1.0"?><Request><Header><Operation>UpdateGlobalProfile</Operation><Handle>'+handle+'</Handle></Header><Body><ClientConnection><Name>'+params[0]+'</Name></ClientConnection></Body></Request>';
  if (debug_On==true)
	  logReq("UpdateGlobalProfile",aux);
  return aux;
}

function XML_removeJMS(handle, params)
// returns the xml request to remove a JMS connection
{
  var aux='<?xml version="1.0"?><Request><Header><Operation>UpdateGlobalProfile</Operation><Handle>'+handle+'</Handle><Type>JMS</Type></Header><Body><Context><Name>'+params[0]+'</Name></Context></Body></Request>';
  if (debug_On==true)
	  logReq("UpdateGlobalProfile",aux);
  return aux;
}
//TODO parms size == 7 if new params == 8 if update 
function XML_UpdateGPCl(handle,params)
// returns the xml request to update a cl. connection from the global profile
{
	 //alert(params.length);
	 var svalue = "";
	 for(i=0;i<params.length;i++){
		 svalue += i + ": [" + params[i] +"]\n";
	 }
	 //alert(svalue);
 var aux= '<?xml version="1.0"?><Request><Header><Operation>UpdateGlobalProfile</Operation><Handle>'+handle+'</Handle></Header><Body><ClientConnection><Name>'+params[7]+'</Name><Resource>'+params[0]+'</Resource><Host>'+params[1]+'</Host><Channel>'+params[2]+'</Channel><Port>'+params[3]+'</Port>';
 if(rtrim(ltrim(params[4])) != "")
 	aux += '<CCSID>'+params[4]+'</CCSID>';
 //lidongq add default module queue
 if(params[8] && rtrim(ltrim(params[8])) != "")
	aux += '<DefaultModuleQueue>'+params[8]+'</DefaultModuleQueue>';
 
 if(params[5].length != 0)
 {
 	aux += "<Properties>";
 	for(var i = 0; i < params[5].length; i++)
 	{
 		aux += "<Property><Name>"+ params[5][i] + "</Name><Value>" + params[6][i] + "</Value></Property>"; 
 	}
 	aux += "</Properties>";
 }
 aux += '</ClientConnection></Body></Request>';
 if (debug_On==true)
	  logReq("UpdateGlobalProfile",aux);

  return aux; 
}

 


function XML_UpdateGPJMS(handle,params)
// returns the xml request to update a jms connection from the global profile
{

 var aux= '<?xml version="1.0"?><Request><Header><Operation>UpdateGlobalProfile</Operation><Handle>'+handle+'</Handle><Type>JMS</Type></Header><Body><Context><Name>'+params[0]+'</Name><URL>'+params[1]+'</URL><Factory>'+params[2]+'</Factory><Provider>'+params[3]+'</Provider>';
 if(params[4] != null && params[4] != "")
 	aux += '<Vendor>'+params[4]+'</Vendor>';
 if(params[5] != 0){
 aux += "<Properties>";
 for(var i =6; i< params.length; i=i+2){
 	if(params[i] != null && params[i+1] != null && params[i] != "" && params[i+1] != "")
 		aux += "<Property><Name>"+ params[i]+"</Name><Value>"+params[i+1]+"</Value></Property>";
 }
 aux += "</Properties>";
 }
 
 aux += "</Context></Body></Request>";

    if (debug_On==true)
	  logReq("UpdateGlobalProfile",aux);
  return aux;
}


//********************************************************************************
//**********************				**************************
//**********************	LIST FUNCTIONS		**************************
//**********************				**************************
//********************************************************************************

function XML_getXMLCreateConnection(name,type,handle,clname,clPro)
// returns the xml request to create a connection
{
	var xml;
	if (clname==null)
	   xml='<?xml version="1.0"?><Request><Header><Operation>CreateConnection</Operation><Handle>'+handle+'</Handle></Header><Body><MessagingType>'+type+'</MessagingType><Resource>'+name+'</Resource></Body></Request>';
	else
	{
	   xml='<?xml version="1.0"?><Request><Header><Operation>CreateConnection</Operation><Handle>'+handle+'</Handle></Header><Body><MessagingType>'+type+'</MessagingType><ClientConnection>'+clname+'</ClientConnection>';
	   if(clPro != null)
	   {  
	   	if(clPro[0].length != 0)
			xml += '<UserId>' + clPro[0] + '</UserId><Password>' + clPro[1] + '</Password>';
		var len = clPro.length;
		if(len > 2)
		{
			var clLen = clPro[2].length;
			if(clLen > 0)
			{
				xml += '<securityExit>';
				for(i=0; i < clLen; i++)
				{
					xml += '<' + clPro[2][i] + '>' + clPro[3][i] + '</' + clPro[2][i] + '>';
				}
				xml += '</securityExit>';
			}
		}	
	   }
	   xml += '</Body></Request>';
	}

  if (debug_On==true)
	  logReq("CreateConnection",xml);
return xml;
}

function XML_getXMLClose(handle,connid)
// returns the xml request to close a connection
{
 var aux='<?xml version="1.0"?><Request><Header><Operation>CloseBackend</Operation><Handle>'+handle+'</Handle><ConnId>'+connid+'</ConnId></Header></Request>';
  if (debug_On==true)
	  logReq("CloseBackend",aux);
  return aux;
}


function XML_getXMLListQueues(handle,connid,type,qname)
// returns the xml request to list queues
{var aux;
 if (type!=null)
  aux= '<?xml version="1.0"?><Request><Header><Operation>ListQueues</Operation><Handle>'+handle+'</Handle><ConnId>'+connid+'</ConnId></Header><Body><QType>'+type+'</QType>';
 else
  aux= '<?xml version="1.0"?><Request><Header><Operation>ListQueues</Operation><Handle>'+handle+'</Handle><ConnId>'+connid+'</ConnId></Header><Body>';
 if ((qname)&&(qname!=''))
	aux+="<QName>"+qname+"</QName>";
 aux+='</Body></Request>';
 if (debug_On==true)
	  logReq("ListQueues",aux);
  return aux;
}

function XML_RefreshQueues(handle,connid,name,type,sortBy)
{
var xml = '<?xml version="1.0" ?><Request><Header><Operation>RefreshQueues</Operation><Handle>'+handle+'</Handle><ConnId>'+connid+'</ConnId></Header><Body>';
if(name != "")
	xml += '<QName>'+name+'</QName>';
if(sortBy != undefined)
	xml += '<Sort>'+sortBy+'</Sort>';
xml += '<QType>'+type+'</QType></Body></Request>';
return xml;
}



function XML_DisplayQueue(handle,connid,name,attrib,type,count)
{
	var xml = '<?xml version="1.0"?><Request><Header><Operation>DisplayQueue</Operation><Handle>'+handle+'</Handle><ConnId>'+connid+'</ConnId></Header>';
	var xml_name = "";
	var xml_type = "";
	var xml_filter = "";
	var xml_count = "";
	if(name != null && name != "" && name.length > 0)
		for(var w = 0; w < name.length; w++)
			xml_name += "<QName>"+name[w]+"</QName>";
	if(type != null && type != "" )
		xml_name += "<QType>"+type+"</QType>";
	if(count != null && count != "" )
		xml_count += "<Count>"+count+"</Count>";
	if(attrib != null && attrib.length > 0)
	{
		var xml_filter = "<Filter>";
		    for (var q = 0; q < attrib.length; q++)
		      	xml_filter += "<Attribute>"+ attrib[q] +"</Attribute>";
		    xml_filter += "</Filter>";
	}
	if(name != null || (attrib != null && attrib.length > 0))
		xml += "<Body>" + xml_name + xml_type + xml_count + xml_filter + "</Body>";
	xml += "</Request>";
	return xml;
}


function XML_ClearQueue(handle,connid,name)
{
	var xml = '<?xml version="1.0"?><Request><Header><Operation>ClearQueue</Operation><Handle>'+handle+'</Handle><ConnId>'+connid+'</ConnId></Header><Body><QName>'+name+'</QName></Body></Request>';
	return xml;
}


function XML_getXMLCreateQueue(type,params,handle,connid)
// returns the xml request to create a queue
{
var xml='<?xml version="1.0"?><Request><Header><Operation>CreateQueue</Operation><Handle>'+handle+'</Handle><ConnId>'+connid+'</ConnId></Header><Body>';
if (type == TYPEMQ)
	xml += '<QName>'+params[0]+'</QName>';
else
	xml += '<QName><![CDATA['+params[0]+']]></QName>';
var MQtags=new Array();
MQtags[0] = 'QName';
MQtags[1] = 'QType';
MQtags[2] = 'Replace';
MQtags[3] = 'QDesc';
MQtags[4] = 'InhibitPut';
MQtags[5] = 'DefPriority';
MQtags[6] = 'DefPersistence';
MQtags[7] = 'InhibitGet';
MQtags[8] = 'BaseQName';
MQtags[9] = 'ProcessName';
MQtags[10] = 'MaxQDepth';
MQtags[11] = 'MaxMsgLength';
MQtags[12] = 'BackoutThreshold';
MQtags[13] = 'BackoutRequeueName';
MQtags[14] = 'Shareability';
MQtags[15] = 'DefInputOpenOption';
MQtags[16] = 'HardenGetBackout';
MQtags[17] = 'MsgDeliverySequence';
MQtags[18] = 'RetentionInterval';
MQtags[19] = 'DistLists';
MQtags[20] = 'Usage';
MQtags[21] = 'InitiationQName';
MQtags[22] = 'TriggerControl';
MQtags[23] = 'TriggerType';
MQtags[24] = 'TriggerMsgPriority';
MQtags[25] = 'TriggerDepth';
MQtags[26] = 'TriggerData';
MQtags[27] = 'RemoteQName';
MQtags[28] = 'RemoteQMgrName';
MQtags[29] = 'XmitQName';
MQtags[30] = 'DefinitionType';
MQtags[31] = 'Scope';
MQtags[32] = 'QDepthHighLimit';
MQtags[33] = 'QDepthLowLimit';
MQtags[34] = 'QDepthMaxEvent';
MQtags[35] = 'QDepthHighEvent';
MQtags[36] = 'QDepthLowEvent';
MQtags[37] = 'QServiceInterval';
MQtags[38] = 'QServiceIntervalEvent';
MQtags[39] = 'RemoteQName';
MQtags[40] = 'RemoteQMgrName';
MQtags[41] = 'XmitQName';
MQtags[42] = 'Scope';
MQtags[43] = 'BaseQName';
MQtags[44] = 'Scope';
MQtags[45] = 'InhibitGet';
var i; 
  if (type==TYPEMQ)
   {
	xml=xml+'<QType>'+params[1]+'</QType>';
	for (i=2;i<params.length;i++) 
		if(rtrim(ltrim(params[i])).length != 0) 
		{
			if(MQtags[i] == 'QDesc')
				xml=xml+'<'+MQtags[i]+'><![CDATA['+params[i]+']]></'+MQtags[i]+'>';
			else
				xml=xml+'<'+MQtags[i]+'>'+params[i]+'</'+MQtags[i]+'>';
		}
   }
  xml=xml+'</Body></Request>';
  if (debug_On==true)
	  logReq("CreateQueue",xml);
  return xml;
}



function XML_getXMLDelete(handle,connid,name,purge)
// returns the xml request to delete a queue
{
  var aux= '<?xml version="1.0"?><Request><Header><Operation>DeleteQueue</Operation><Handle>'+handle+'</Handle><ConnId>'+connid+'</ConnId></Header><Body>';
  aux += '<QName><![CDATA['+name+']]></QName>';
  aux += '<Purge>'+purge+'</Purge></Body></Request>';
  if (debug_On==true)
	  logReq("DeleteQueue",aux);
  return aux;
}

function XML_getXMLGlobalProfile(handle)
// returns the xml request to obtain the global profile from the server
{
   var aux= '<?xml version="1.0"?><Request><Header><Operation>GetGlobalProfile</Operation><Handle>'+handle+'</Handle></Header></Request>';
  if (debug_On==true)
	  logReq("GetGlobalProfile",aux);
  return aux;
}

function XML_getXMLUserProfile(handle)
// returns the xml request to obtain the user's profile from the server
{
   var aux= '<?xml version="1.0"?><Request><Header><Operation>GetUserProfile</Operation><Handle>'+handle+'</Handle></Header></Request>';
  if (debug_On==true)
	  logReq("GetUserProfile",aux);
  return aux;
}

function XML_updateXMLUserProfile(handle,conID,profile)
// sends request to server to update user profile
{
var qmanager = ActiveQmgr;
if(browser == "NS"){
    var aux= '<?xml version="1.0"?><Request><Header><Operation>UpdateUserProfile</Operation><Handle>'+handle+'</Handle></Header><Body><Backend>'+qmanager+'</Backend><Type>'+QType+'</Type>'+serializeXML(profile)+'</Body></Request>';
    if (debug_On==true)
	  logReq("UpdateUserProfile",aux);
    return aux;
}
else{
	var aux= '<?xml version="1.0"?><Request><Header><Operation>UpdateUserProfile</Operation><Handle>'+handle+'</Handle></Header><Body><Backend>'+qmanager+'</Backend><Type>'+QType+'</Type>'+profile.xml+'</Body></Request>';
	if (debug_On==true)
		  logReq("UpdateUserProfile",aux);
	  return aux;
}
}

function XML_updateXMLUserProfileStr(handle,conID,profile)
// sends request to server to update user profile
{
var qmanager = ActiveQmgr;
   var aux= '<?xml version="1.0"?><Request><Header><Operation>UpdateUserProfile</Operation><Handle>'+handle+'</Handle></Header><Body><Backend>'+qmanager+'</Backend><Type>'+QType+'</Type>'+profile+'</Body></Request>';
  if (debug_On==true)
	  logReq("UpdateUserProfile",aux);
  return aux;
}

//********************************************************************************
//**********************				**************************
//**********************	Message Window		**************************
//**********************				**************************
//********************************************************************************

function XML_openQueue(handle,connid,options)
{

  var xml="<?xml version='1.0'?><Request><Header><Operation>AccessQueue</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body>";
  xml += '<QName><![CDATA['+options[0]+']]></QName>';
  var i;
  var j=13;
  if ((options[1]!='null')&&(options[1]!="'undefined'"))
	xml=xml+"<ProcessingMode>"+options[1]+"</ProcessingMode>";
  if (QType==TYPEMQ)
  {

	  if (options[2]!='null')
		xml=xml+"<Context>"+options[2]+"</Context>";
	  if ((options[3]!='null')&&(options[3]=='true'))
		xml=xml+"<LogicalOrder>Yes</LogicalOrder>";
	  if ((options[4]!='null')&&(options[4]=='true'))
		xml=xml+"<AssembleSegments>Yes</AssembleSegments>";
  
	xml=xml+"<OpenOptions>";
	  for (i=5;i<=8;i++)
	  {
		if ((options[i]!='null') && (options[i]!="false")&& (options[i]!=null)&&(options[i]!="'undefined'"))
			xml=xml+'<Option>'+options[i]+'</Option>';
	  }
	xml=xml+"</OpenOptions>";
}
	if ((options[9]!='null')&&(options[9]=='true'))
		xml=xml+"<UseMDR>No</UseMDR>";
	if (options[12]!='null')
		xml=xml+"<FieldSize>"+options[12]+"</FieldSize>";
	if (options[13]!='null')
		xml=xml+"<FieldCount>"+options[13]+"</FieldCount>";

//row filters
var j=15;
var q=0;
var start=0;
appliedFilters = new Array();

 start=14;

  if (options[start]&&(options[start]!='null')&&(options[start]!=0))
  {
	appliedFilters[q++]=options[start];
	xml=xml+"<RowDataFilter>";
	flt=0;
        for (p=0;p<options[start];p++)
		flt++;

	for (j=start+1;j<=start+flt;j++)
	{
		xml=xml+"<Filter>"+options[j]+"</Filter>";
		appliedFilters[q++]=options[j];
	}
	xml=xml+"</RowDataFilter>";
		
  }else	{
	appliedFilters[0]=0; // there are 0 applied filters
	q=1;
  }

//column filters
var k=j+1;

  if (options[j]&&(options[j]!='null')&&(options[j]!=0))
  {
	appliedFilters[q++]=options[j];
	xml=xml+"<ColumnDataFilter>";
	flt=0;
        for (p=0;p<options[j];p++)
		flt++;

	for (k=j+1;k<=j+flt;k++)
	{
		xml=xml+"<Filter>"+options[k]+"</Filter>";
		appliedFilters[q++]=options[k];
	}
	xml=xml+"</ColumnDataFilter>";
		
  }else
	appliedFilters[q++]=0; // there are 0 column filters applied

//row header filters
j=k+1;
  if ((options[k]!=null)&&(options[k]!=0))
  {
	appliedFilters[q++]=options[k];
	xml=xml+"<RowHeaderFilter>";
	flt=0;
        for (p=0;p<options[k];p++)
		flt++;

	for (j=k+1;j<=k+flt;j++)
	{
		xml=xml+"<Filter>"+options[j]+"</Filter>";
		appliedFilters[q++]=options[j];
	}
	xml=xml+"</RowHeaderFilter>";
		
  }else
	appliedFilters[q++]=0; // there are 0 row header filters applied


//column header filters

  if ((options[j]!=null)&&(options[j]!=0))
  {
	appliedFilters[q++]=options[j];
	xml=xml+"<ColumnHeaderFilter>";
	flt=0;
        for (p=0;p<options[j];p++)
		flt++;

	for (k=j+1;k<=j+flt;k++)
	{
		xml=xml+"<Filter>"+options[k]+"</Filter>";
		appliedFilters[q++]=options[k];
	}
	xml=xml+"</ColumnHeaderFilter>";
		
  }else
	appliedFilters[q]=0; // there are 0 row header filters applied
	  

  xml=xml+'</Body></Request>';
  if (debug_On==true)
	  logReq("AccessQueue",xml);

  return xml;
}


function XML_refresh(handle,connid)
{
 var aux='<?xml version="1.0"?><Request><Header><Operation>Refresh</Operation><Handle>'+handle+'</Handle><ConnId>'+connid+'</ConnId></Header></Request>';
  if (debug_On==true)
	  logReq("Refresh",aux);
  return aux;
}


function XML_Buffer(handle,connid)
{
	
 var aux='<?xml version="1.0"?><Request><Header><Operation>Peek</Operation><Handle>'+handle+'</Handle><ConnId>'+connid+'</ConnId></Header><Body><Mode>Buffer</Mode></Body></Request>';
  if (debug_On==true)
	  logReq("Buffer",aux);
  return aux;
}



function XML_peek(handle,connid,params,Tag)
{
  var xml="<?xml version='1.0'?><Request><Header><Operation>Peek</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body>";

  for (var i=0;i<params.length;i++)    
  {
	    if (params[i]!="" && params[i]!=null)
		xml=xml+"<"+Tag[i]+">"+params[i]+"</"+Tag[i]+">";
  }
 xml=xml+"</Body></Request>";
 if (debug_On==true)
	 logReq("Peek",xml);
 return xml;
}

function XML_listAvailFmt(handle,connid,sysFmt)
{
  var aux= "<?xml version='1.0'?><Request><Header><Operation>ListFormats</Operation><Handle>"+handle+"</Handle></Header><Body>";
  if(sysFmt)
  	aux += "<Namespace>:CandleInternal.MessageEditor</Namespace>";
  	
  aux += "</Body></Request>";
  if (debug_On==true)
	  logReq("ListFormats",aux);
  return aux;
}

function XML_createMess(handle,connid,msg,col,val)
{

 var xml="<?xml version='1.0'?><Request><Header><Operation>Write</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body>";

  if ((col!=null)&&(val!=null))
    if (col.length==val.length)
    {
		xml=xml+"<Message>"+msg;
	  	for (i=0;i<col.length;i++)
		{
			xmlaux="<Hexa><Field>"+col[i]+"</Field><Value>"+val[i]+"</Value></Hexa>";
			xml=xml+xmlaux;
		}
		xml=xml+"</Message>";
    }
    else
	return null;
  else
	xml=xml+"<Message>"+msg+"</Message>";

  xml=xml+"</Body></Request>";  
  
  if (debug_On==true)
	  logReq("Write",xml);

  return xml;

}

function XML_getMetaData(handle,connid,fmt)
{
  var aux= "<?xml version='1.0'?><Request><Header><Operation>GetMetadata</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body><Name>"+fmt+"</Name></Body></Request>";
  if (debug_On==true)
	  logReq("GetMetadata",aux);
  return aux;
}

function XML_getHeaderMetaData(handle,connid,fmt)
{
  var aux= "<?xml version='1.0'?><Request><Header><Operation>GetMetadata</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body><Name>"+fmt+"</Name><Namespace>:CandleInternal.MessageEditor</Namespace></Body></Request>";
  if (debug_On==true)
	  logReq("GetMetaData",aux);
  return aux;
}

function XML_closeQ(handle,connid)
{
   var aux= "<?xml version='1.0'?><Request><Header><Operation>CloseQueue</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header></Request>";
  if (debug_On==true)
	  logReq("CloseQueue",aux);
  return aux;
}

function XML_deleteMsg(handle,connid,ids)
{
  var xml="<?xml version='1.0'?><Request><Header><Operation>Read</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body><Messages>";
  var i;
  for (i=0;i<ids.length;i++)
  {
     xml=xml+"<ConnId>"+ids[i]+"</ConnId>";
   }
   xml=xml+"</Messages></Body></Request>";
  if (debug_On==true)
	  logReq("Read",xml);
  return xml;
}

function XML_copyMsg(handle,connid,ids)
{
  var xml="<?xml version='1.0'?><Request><Header><Operation>Copy</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body><Messages>";
  var i;

  for (i=0;i<ids.length;i++)
  {
     xml=xml+"<ConnId>"+ids[i]+"</ConnId>";
   }
   xml=xml+"</Messages></Body></Request>";
  if (debug_On==true)
	  logReq("Copy",xml);
  return xml;
}

function XML_cutMsg(handle,connid,ids)
{
  var xml="<?xml version='1.0'?><Request><Header><Operation>Cut</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body><Messages>";
  var i;
  for (i=0;i<ids.length;i++)
  {
     xml=xml+"<ConnId>"+ids[i]+"</ConnId>";
   }
   xml=xml+"</Messages></Body></Request>";
  if (debug_On==true)
	  logReq("Cut",xml);
  return xml;
}

function XML_paste(handle,connid,mode)
{
  var aux= "<?xml version='1.0'?><Request><Header><Operation>Paste</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body><Refresh>"+mode+"</Refresh></Body></Request>";
  if (debug_On==true)
	  logReq("Paste",aux);
  return aux;
}

function XML_forward(handle,connid,qname,qmgr,ids,strip,retry)
{
  var xml="<?xml version='1.0'?><Request><Header><Operation>Forward</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body>";

  if ((qname!='null')&&(qname!=null))
	xml+="<QName>"+qname+"</QName>";

  xml+="<Messages>";
  var i;
  for (i=0;i<ids.length;i++)
  {
     xml=xml+"<ConnId>"+ids[i]+"</ConnId>";
   }
  xml=xml+"</Messages>"

  if (retry=='yes')
  	xml+="<Retry>"+retry+"</Retry>";
  else{
  	if (qmgr!="")
		xml=xml+"<Resource>"+qmgr+"</Resource>";  
	  if (strip=="true")
		xml+="<Strip>yes</Strip>";
  }
  xml=xml+"</Body></Request>";
if (debug_On==true)
  logReq("Forward",xml);
return xml;  
}

function XML_availFiles(handle,connid,common,fileFilter)
{
  var aux= "<?xml version='1.0'?><Request><Header><Operation>ListMessageFiles</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header>";
  aux = aux + "<Body><FileFilter>" + fileFilter + "</FileFilter>";
  if (common == true) aux = aux + "<CommonDir>Yes</CommonDir>";
  aux = aux + "</Body></Request>";
  if (debug_On==true)
	  logReq("ListMessageFiles",aux);
  return aux;
}

function XML_load(handle,connid,props)
{
  var aux= "<?xml version='1.0'?><Request><Header><Operation>Load</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body><File>"+props[0]+"</File>";
  if(props.length > 1)
  {
  	if(props[1].length > 0 && props[1] != "none")
  	{
  		aux += "<Attributes>";
  		for(var i =1; i < props.length; i++){
   			aux += "<Attribute>"+ props[i] + "</Attribute>";
  		}
  		aux += "</Attributes>";
  	}
  	else
  		if(props[1] == "none")
  			aux += "<Attributes></Attributes>";
  		
  }
  
  aux += "</Body></Request>";
  if (debug_On==true)
	  logReq("Load",aux);
  return aux;
}

function XML_unload(handle,connid,file,append,ids,deleteMessages,toXML,separate,header,split)
{
   var xml="<?xml version='1.0'?><Request><Header><Operation>Unload</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body><File>"+file+"</File>";
   if ((append!="")&&(append!=null))
	xml=xml+"<Append>"+append+"</Append>";
	
   if ((deleteMessages!="")&&(deleteMessages!=null))
	xml=xml+"<Delete>"+deleteMessages+"</Delete>";   
	
   if ((ids!=null) && (ids!=""))
   {
 	xml=xml+"<Messages>";
	for (i=0;i<ids.length;i++)
		xml=xml+"<ConnId>"+ids[i]+"</ConnId>";
	xml=xml+"</Messages>";
   }
   
   if ((ids!=null) && (ids==""))
   {
 	xml=xml+"<All>yes</All>";
   }
	if ((toXML!=null))
   {
 	xml=xml+"<XML>"+toXML+"</XML>";
   }
   	if ((separate!=null))
   {
 	xml=xml+"<Separate>"+separate+"</Separate>";
   }
	if ((header!=null))
   {
 	xml=xml+"<Hasheader>"+header+"</Hasheader>";
   }
	if ((split!=null))
   {
 	xml=xml+"<Split>"+split+"</Split>";
   }
	
   xml=xml+"</Body></Request>";
  if (debug_On==true)
	  logReq("Unload",xml);
   return xml;
}
//zhou parse unknownformat message
function XML_ParseMsgAgain(handle,connid,field,id)
{
  var aux= "<?xml version='1.0'?><Request><Header><Operation>ParseMsgAgain</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body><ConnId>"+id+"</ConnId>";
  if(field != "")
  	aux += "<Field>"+field+"</Field>";

  aux += "</Body></Request>";  
  
  if (debug_On==true)
	  logReq("ParseMsgAgain",aux);
	  
  return aux;
}

function XML_ParseIngoreMsgAgain(handle,connid,field,id)
{
  var aux= "<?xml version='1.0'?><Request><Header><Operation>ParseIngoreMsgAgain</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body><ConnId>"+id+"</ConnId>";
  if(field != "")
  	aux += "<Field>"+field+"</Field>";

  aux += "</Body></Request>";  
  
  if (debug_On==true)
	  logReq("ParseIngoreMsgAgain",aux);
	  
  return aux;
}

function XML_setHexValue(handle,connidQ,connidMessage,field,value)
{
  var aux= "<?xml version='1.0'?><Request><Header><Operation>SetHexaDecimal</Operation><Handle>"+handle+"</Handle><ConnId>"+connidQ+"</ConnId></Header><Body><ConnId>"+connidMessage+"</ConnId><Value>"+value+"</Value><Field>"+field+"</Field></Body></Request>";  
  if (debug_On==true)
	  logReq("SetHexaDecimal",aux);
  return aux;
}

function XML_getHexValue(handle,connid,field,id)
{
	
  var aux= "<?xml version='1.0'?><Request><Header><Operation>GetHexaDecimal</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body><ConnId>"+id+"</ConnId>";
  if(field != "")
  	aux += "<Field>"+field+"</Field>";

  aux += "</Body></Request>";  
  if (debug_On==true)
	  logReq("GetHexaDecimal",aux);
  return aux;
}


function XML_getHex(handle,connid,value,CCSID)
{
  var aux= "<?xml version='1.0'?><Request><Header><Operation>GetHexaValue</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body>";

  if(value && value != "")
  	aux += "<Value>"+value+"</Value><CCSID>"+CCSID+"</CCSID>";
  
  aux += "</Body></Request>";  
  if (debug_On==true)
	  logReq("GetHexa",aux);
  return aux;
}


function XML_getText(handle,connid,value,CCSID)
{
  var aux= "<?xml version='1.0'?><Request><Header><Operation>GetTextValue</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body>";

  if(value && value != "")
  	aux += "<Value>"+value+"</Value><CCSID>"+CCSID+"</CCSID>";
  
  aux += "</Body></Request>";  
  
  if (debug_On==true)
	  logReq("GetText",aux);
  return aux;
}



function XML_update(handle,connid,msg,kxyType,col,val,colName)
{
	
if((kxyType == 'MDR_XML' && hasProperties == 0) || kxyType == 'STANDALONE' || kxyType == 'RAW_TEXT' || kxyType == 'RAW_HEXA' || kxyType == 'Map' || kxyType == 'Stream')
	return "<?xml version='1.0'?><Request><Header><Operation>Update</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body>"+msg+"</Body></Request>"; 
else
{
	  var xml="<?xml version='1.0'?><Request><Header><Operation>Update</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body><Message>"+msg +"</Message></Body></Request>";  
  if (debug_On==true)
	  logReq("Update",xml);

  return xml;
  }
}


function XML_commit(handle,connid)
{
  var aux= "<?xml version='1.0'?><Request><Header><Operation>Commit</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header></Request>";  
  if (debug_On==true)
	  logReq("Commit",aux);
  return aux;
}

function XML_rollback(handle,connid)
{
  var aux= "<?xml version='1.0'?><Request><Header><Operation>Rollback</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header></Request>";  
  if (debug_On==true)
	  logReq("Rollback",aux);
  return aux;
}

function XML_find(handle,connid,column,value,mode,kxyT,check,fmt,index,all)
{
  var xml="<?xml version='1.0'?><Request><Header><Operation>Find</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header><Body>";
  if(fmt == "Stream")
  {
  	var temp = parseInt(index) - 1;
  	xml += "<Column>"+column+"["+temp+"]"+"</Column>";
  
  }else
  	xml += "<Column>"+column+"</Column>";
  	
  var len = value.length;
  var flag = 0;
  var index = value.indexOf("]]>");
  while(index != -1)
  {
  	flag = flag+1;
  	xml += "<Value><![CDATA["+value.substring(0, index + 1)+"]]></Value>";
  	value = value.substring(index+1,value.length);
  	index = value.indexOf("]]>");
  }
  xml += "<Value><![CDATA["+value+"]]></Value>";

 	  		 
  if (mode!=null)
	xml=xml+"<Mode>"+mode+"</Mode>";
if(kxyT != null && kxyT == "Header")
	xml=xml+"<ColumnType>"+kxyT+"</ColumnType>";
else
{
 	xml=xml+"<Type>"+kxyT+"</Type>";
  	if (fmt!=null && fmt != "null")
  	{
  		if(fmt != "Stream" && fmt != "Map")
  		{
 			if(selectedFmt != "null")
 				xml=xml+"<Format>"+selectedFmt+"</Format>";
 			xml = xml + "<pFormat>"+selectedpFmt+"</pFormat>";
 		}
 		else
 			xml=xml+"<BodyType>"+fmt+"</BodyType>";
 	}
 }

 if (check=="yes")
	xml=xml+"<Case>"+check+"</Case>";
 if (all)
	xml=xml+"<All>Yes</All>";

 xml=xml+"</Body></Request>";
  if (debug_On==true)
	  logReq("Find",xml);
  return xml;
}

function XML_saveFilter(handle,name,type,format,expression,selector)
{
 var aux= "<?xml version='1.0'?><Request><Header><Operation>AddFilter</Operation><Handle>"+handle+"</Handle></Header><Body><Name>"+name+"</Name><Type>"+type+"</Type><Selector>"+selector+"</Selector><Format>"+format+"</Format><Value><![CDATA["+expression+"]]></Value></Body></Request>";  
  if (debug_On==true)
	  logReq("AddFilter",aux);
  return aux;
}

function XML_updateFilter(handle,name,type,format,expression,selector)
{
 var aux= "<?xml version='1.0'?><Request><Header><Operation>UpdateFilter</Operation><Handle>"+handle+"</Handle></Header><Body><Name>"+name+"</Name><Type>"+type+"</Type><Selector>"+selector+"</Selector><Format>"+format+"</Format><Value><![CDATA["+expression+"]]></Value></Body></Request>";  
   if (debug_On==true)
	  logReq("UpdateFilter",aux);
  return aux;
}

function XML_delFilter(handle,name,type,format,expression)
{
 var aux= "<?xml version='1.0'?><Request><Header><Operation>DeleteFilter</Operation><Handle>"+handle+"</Handle></Header><Body><Name>"+name+"</Name></Body></Request>";  
  if (debug_On==true)
	  logReq("DeleteFilter",aux);
  return aux;
}

function XML_getFilters(handle,name,type,format,expression,selector,sysFmt)
{
 var xml= "<?xml version='1.0'?><Request><Header><Operation>GetFilters</Operation><Handle>"+handle+"</Handle></Header>";
 if((name != null && name != "") || (type != null && type != "") || (format != null && format != "") || (expression != null && expression != "") || (selector != null && selector != "") || (sysFmt != null)){
 	xml += "<Body>";
 	if(name != null && name != "")
 		xml += "<Name>"+name+"</Name>";
 	if(type != null && type != "")
 		xml += "<Type>"+type+"</Type>";
 	if(format != null && format != "" && format != " ")
 		xml += "<Format>"+format+"</Format>";
 	if(expression != null && expression != "")
 		xml += "<Owner>"+expression+"</Owner>";
  	if(selector != null && selector != "")
 		xml += "<Selector>"+selector+"</Selector>";
 	
 	if(sysFmt)
 		xml += "<Namespace>"+sysFmt+"</Namespace>";
 		
 	xml +="</Body>";
 }
 xml += "</Request>";  
  if (debug_On==true)
	  logReq("GetFilters",xml);
 return xml;
}


function XML_addVariant(handle,name,filter,message_format,real_format)
{
 var aux= "<?xml version='1.0'?><Request><Header><Operation>AddVariant</Operation><Handle>"+handle+"</Handle></Header><Body><Name>"+name+"</Name><Filter>"+filter+"</Filter><Format>"+message_format+"</Format><RealFormat>"+real_format+"</RealFormat></Body></Request>";  
  if (debug_On==true)
	  logReq("AddVariant",aux);
  return aux;
}


function XML_getVariants(handle,name,filter,message_format,real_format,owner)
{
 var xml= "<?xml version='1.0'?><Request><Header><Operation>GetVariants</Operation><Handle>"+handle+"</Handle></Header>";
 if((name != null && name != "") || (filter != null && filter != "") || (message_format != null && message_format != "") || (real_format != null && real_format != "") || (owner != null && owner != "")){
 	xml += "<Body>";
 	if(name != null && name != "")
 		xml += "<Name>"+name+"</Name>";
 	if(filter != null && filter != "")
 		xml += "<Filter>"+filter+"</Filter>";
 	if(message_format != null && message_format != "" && message_format != " ")
 		xml += "<Format>"+message_format+"</Format>";
 	if(real_format != null && real_format != "")
 		xml += "<RealFormat>"+real_format+"</RealFormat>";
  	if(owner != null && owner != "")
 		xml += "<Owner>"+owner+"</Owner>";
 		
 	xml +="</Body>";
 }
 xml += "</Request>";  
  if (debug_On==true)
	  logReq("GetVariants",xml);
 return xml;
}


function XML_deleteVariant(handle,name)
{
 var aux= "<?xml version='1.0'?><Request><Header><Operation>DeleteVariant</Operation><Handle>"+handle+"</Handle></Header><Body><Name>"+name+"</Name></Body></Request>";  
  if (debug_On==true)
	  logReq("DeleteVariant",aux);
  return aux;
}

function XML_updateVariant(handle,name,filter,message_format,real_format)
{
 var aux= "<?xml version='1.0'?><Request><Header><Operation>UpdateVariant</Operation><Handle>"+handle+"</Handle></Header><Body><Name>"+name+"</Name><Filter>"+filter+"</Filter><Format>"+message_format+"</Format><RealFormat>"+real_format+"</RealFormat></Body></Request>";  
   if (debug_On==true)
	  logReq("UpdateVariant",aux);
  return aux;
}

function XML_replace(handle,connid,msgconnid,column,old_value,new_value,offset,fmt,kxyT,index)
{

 var xml="<?xml version='1.0' ?><Request><Header><Operation>Replace</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId>";
  xml+="</Header><Body><ConnId>"+msgconnid+"</ConnId>";
   if(fmt == "Stream")
   {
   	var temp = parseInt(index) - 1;
   	xml += "<Column>"+column+"["+temp+"]"+"</Column>";
   
   }else
  	xml += "<Column>"+column+"</Column>";
 
  var len = old_value.length;
  var flag = 0;
  var index = old_value.indexOf("]]>");
  while(index != -1)
  {
  	flag = flag+1;
  	xml += "<OldValue><![CDATA["+old_value.substring(0, index + 1)+"]]></OldValue>";
  	old_value = old_value.substring(index+1,old_value.length);
  	index = old_value.indexOf("]]>");
  }
  xml += "<OldValue><![CDATA["+old_value+"]]></OldValue>";
 
  len = new_value.length;
  flag = 0;
  index = new_value.indexOf("]]>");
  while(index != -1)
  {
  	flag = flag+1;
  	xml += "<NewValue><![CDATA["+new_value.substring(0, index + 1)+"]]></NewValue>";
  	new_value = new_value.substring(index+1,new_value.length);
  	index = new_value.indexOf("]]>");
  }
  
 xml += "<NewValue><![CDATA["+new_value+"]]></NewValue>";
 
 xml += "<Offset>"+offset+"</Offset>";
 
 if(kxyT != null && kxyT == "Header")
 	xml=xml+"<ColumnType>"+kxyT+"</ColumnType>";
 else
 if (fmt!=null)
	xml=xml+"<Format>"+fmt+"</Format>";
  xml += "</Body></Request>";
  return xml;
}

function XML_apply(handle,connid,doapply,col,kxyT,index,fmt)
{
 var xml="<?xml version='1.0' ?><Request><Header><Operation>Apply</Operation><Handle>"+handle+"</Handle><ConnId>"+connid+"</ConnId></Header>";

 if(!doapply)
 {
 	xml += "<Body><Cancel>Yes</Cancel>";
	  if(fmt == "Stream")
	  {
		var temp = parseInt(index) - 1;
		xml += "<Column>"+col+"["+temp+"]"+"</Column>";

	  }else
		xml += "<Column>"+col+"</Column>";
 	
	if(kxyT == "Header")
 		xml += "<ColumnType>Header</ColumnType>";
 	
 	xml += "</Body>";
 }
 xml += "</Request>";
 return xml;
}



function XML_ListMBCS(handle)
{

 var xml="<?xml version='1.0' ?><Request><Header><Operation>ListMBCS</Operation><Handle>"+handle+"</Handle></Header></Request>";
 return xml;
}


function XML_HoldTimer(handle,cancel)
{
	//alert("kxyxml.js hold");
	var xml="<?xml version='1.0'?><Request><Header><Operation>Hold</Operation><Handle>"+handle+"</Handle></Header>";
	if(cancel)
		xml += "<Body><Cancel>Yes</Cancel></Body>";
	xml += "</Request>";
	return xml;
}