/*
#$Id: kxyModal.js,v 1.1.2.1 2009/07/17 05:47:54 dcc Exp $#
######################################################################

             IBM Confidential
             
             OCO Source Materials
             
             (C) Copyright IBM Corp. 2005-2007
             
             The source code for this program is not
             published or otherwise divested of its
             trade secrets, irrespective of what has
             been deposited with the U.S Government
             Copyright Office.

######################################################################
######################################################################
# Copyright 1999-2003, Candle Corporation, a California corporation.  
# All rights reserved. International copyright secured.
#
# This material is proprietary to Candle Corporation and is not to be
# reproduced, used, or disclosed except in accordance with program
# licenses or upon written authorization of Candle Corporation.
#
#######################################################################*/
/**********************************************************************************************
					kxyModal.js
***********************************************************************************************
kxyModal.js has functions that help in opening Modal Dialog windows. 
***********************************************************************************************
***********************************************************************************************/
var winModalWindow;
var hexValueFlag =0;
var headerUpdate = 0;
var beginNS = "";
var message_win = 0;
var dialogName="";
 
 
/**********************************************************************************************
The following three functions - 'IgnoreEvents', 'ShowWindow', and 'HandleFocus' are used in 
making modal pop up dialog windows.
***********************************************************************************************/
function IgnoreEvents(e)
{
    return false;

}


/**********************************************************************************************
The function ShowWindow takes following arguments:
dialogName	: like JMS or Client or createQueue etc.
begin   	: 'new' or 'update' window.
widthPX  	: width of window in pixels.
heightPX  	: height of window in pixels.
paramsForForm   : params to be passed to the form in the pop up modal dialog window.
***********************************************************************************************/

var message_win = 0;

function ShowWindow(dialogName,begin,widthPX,heightPX,paramsForForm)
{
if(windowClose == 0)
{
   beginNS = begin;
   debug_params=[debug_html,debug_request,debug_resp,debug_r,debug_p];
   if(paramsForForm != null)
   paramsForForm[paramsForForm.length+1]=debug_params;

  if (window.showModalDialog)
  {
   if(dialogName == "kxyMsgFr")
   {
   	window.moveTo(1000,1000);
   	var returnValue = window.showModalDialog(dialogName+".htm",paramsForForm,"dialogTop= 0px;dialogWidth='"+widthPX+"';dialogHeight='"+heightPX+"';scroll=no;status=no;caption='no';status=no;menubar=no;resizable=no;minimize='1';titlebar='0';help='no'");
   	window.moveTo(0,0);

   }else 
   if(dialogName == "kxyClLog" && newCredentials == "No")
   {
   	var returnValue = ["","",new Array(),new Array()];
   var result = actionAfterCloseDialog(returnValue,dialogName,paramsForForm,begin);
   //if(result != undefined && result != null)
	return result;

   }else
   	var returnValue = window.showModalDialog(dialogName+".htm",paramsForForm,"dialogWidth='"+widthPX+"';dialogHeight='"+heightPX+"';scroll=no;status=no;caption='no';status=no;menubar=no;resizable=no;titlebar='0';help='no'");
   var result = actionAfterCloseDialog(returnValue,dialogName,paramsForForm,begin);
   if(result != undefined && result != null)
	return result;
  }
  else
  {
  if(message_win == 0 || (message_win == 1 && dialogName != "kxyopnQ")){
	if(dialogName == "kxyMsgFr")
		message_win = 1;
	
if(window.parent != null)
  if(window.parent.frames != null && window.parent.frames.length != 0){

  	for(var i=0; i<window.parent.frames.length;i++){
   		eval(" window.parent.frames["+i+"].captureEvents (Event.FOCUS)");
   		//eval(" window.parent.frames["+i+"].onclick=IgnoreEvents");
   		eval(" window.parent.frames["+i+"].onfocus=HandleFocus");
    	}
    	if(message_win == 0 && window.parent.frame2 != null && window.parent.frame2.frame3 != null){
    		window.parent.frame2.frame3.captureEvents (Event.FOCUS);
   		//window.parent.frame2.frame3.onclick=IgnoreEvents;
   		window.parent.frame2.frame3.onfocus=HandleFocus; 	
    	
    	}
   }
   else{

   	window.parent.captureEvents (Event.FOCUS);
   	//window.parent.onclick=IgnoreEvents;
   	window.parent.onfocus=HandleFocus;   
   
   }

    var w = widthPX;
    var h = heightPX;
    var intWidth = parseInt(widthPX.substring(0,widthPX.length-2));
    var intHeight = parseInt(heightPX.substring(0,heightPX.length-2));
  
    var l = window.screenX + ((window.outerWidth - intWidth) / 2);
    var r = window.screenY + ((window.outerHeight - intHeight) / 2);

    if(dialogName == "kxyMsgFr")
    {
    	h = h - 20;
    	winModalWindow =  window.open(dialogName+".htm","","dependent=yes,resizable = no, width="+w+",height="+h+",screenX="+l+",screenY=0");
    }
    else
    	winModalWindow =  window.open(dialogName+".htm","","dependent=yes,resizable = no, width="+w+",height="+h+",screenX="+l+",screenY="+r+"");
    if (!winModalWindow.opener) winModalWindow.opener = self;
    winModalWindow.focus();
    winModalWindow.dialogArguments = paramsForForm;
    }
  }
  }
  else
  	window.close();
}

function HandleFocus()
{
  if (!winModalWindow.closed)
  {
      winModalWindow.focus() 
      return false;
   }
  else
  {
    if(window.parent.frames.length != 0){
    	for(i=0; i<window.parent.frames.length;i++){
      		eval(" window.parent.frames["+i+"].releaseEvents (Event.FOCUS)");
      	}
      	if(message_win == 0 && window.parent.frame2 != null && window.parent.frame2.frame3 != null){
	    		window.parent.frame2.frame3.releaseEvents (Event.FOCUS);	
	    	
    	}
    } 
    else{
         	window.parent.releaseEvents (Event.FOCUS);
   	}
 
     	return true;
    }
}



function actionAfterCloseDialog(returnValue,dialog,parameters,begin)
{
if(dialog != null && dialog != undefined && dialog != ""){
	var dialogName = dialog;
}
if(parameters != null && parameters != undefined){
	var paramsForForm = parameters;
}
var params1 = new Array();

if(typeof returnValue != "undefined")
  if(typeof returnValue == "string" && (returnValue == "TIMEOUT" || returnValue == "INVALID_SESSION"))
  {	
	if(parent.frame0 != null)
	{
		if(returnValue == "TIMEOUT")
			initializeTimeOut();
		else
			initializeLogout();
	}
	else
	{
		if (win!=null)
			win.close();	
		
		if (debugwin!=null)
			debugwin.close();
		
		if(returnValue == "TIMEOUT")
			timeOut = 1;
		else
			timeOut = 2;
		window.returnValue = returnValue;
		window.close();
		windowClose = 1;	
	}
  }
  else
   {
     if (dialogName=='kxyGetFi'){
     	if(paramsForForm[1] == "row")
     	{
     	if (browser=="NS")
		openF(returnValue);
	else
   		return returnValue;
     	}
     	else
   		return returnValue;
     }else
     if (dialogName=='kxycomit')
     {
     	if(returnValue == "repeat")
		return "repeat";
	else
     	if(returnValue != "cancel")
     	{
     		if(returnValue != "defer")
     		{
     			var return_val;
     			
         		if(paramsForForm[0] != null && paramsForForm[0] == "logout")
         			return_val = "true";
         		else
				return_val = true;	
			
     			if(returnValue == "commit")
     				M_commit(paramsForForm[0]);
     			else
      			if(returnValue == "rollback")
      				M_rollback(paramsForForm[0]);
      				
      			return return_val;		
     		}
     		else
     			return true;
     		
	}
	else
     		if(paramsForForm[0] != null && paramsForForm[0] == "logout")
     			return "false";
     		else
			return false;
     }
     else
     if (dialogName=='kxyGFiRo'){
	 if (browser=="NS")
		openF(returnValue);
	 else
   		return returnValue;
     }
     else
     if (dialogName=='kxyFiMsg'){
   
   		M_applyFilter(returnValue);
     }
     else
     if (dialogName=='kxySvFil')
     {
	M_saveFilter(returnValue[0],returnValue[1],returnValue[2],returnValue[3],returnValue[4],returnValue[5]);
     }
     else
     if (dialogName=='kxyNodes')
     {
		var node_val="";
		if(paramsForForm[1] == 5)
			node_val = returnValue[1];
		if(paramsForForm[1] == 7 || paramsForForm[1] == 1 || paramsForForm[1] == 2 || paramsForForm[1] == 3)
			node_val = returnValue[0];
		if(paramsForForm[1] == 6)
			node_val = returnValue[1];
		if(paramsForForm[1] == 1)
		{
			if(paramsForForm[3] != null)
				createChild(paramsForForm[0],returnValue[0],returnValue[2]);
			else
				parent.createChild(paramsForForm[0],returnValue[0],paramsForForm[1]);
		}
		if(paramsForForm[1] == 2)
			parent.createChildAttribute(paramsForForm[0],returnValue[0],returnValue[1]);	
		if(paramsForForm[1] == 3)
			if(paramsForForm[3] != null)
				createChildText(paramsForForm[0],returnValue[0],paramsForForm[1]);	
			else
				parent.createChildText(paramsForForm[0],returnValue[0],paramsForForm[1]);	
		if(returnValue[0] == "yes"){
			if(paramsForForm[1] == 4)
				if(paramsForForm[3] != null)
					removeChild(paramsForForm[0],returnValue[0],paramsForForm[1]);
				else
					parent.removeChild(paramsForForm[0],returnValue[0],paramsForForm[1]);
			if(paramsForForm[1] == 5)
					parent.removeAttribute(paramsForForm[0],returnValue[1],paramsForForm[1]);
		}
		if(paramsForForm[1] == 6){
			if(paramsForForm[3] != null)
				addSibling(paramsForForm[0],returnValue[0],returnValue[1],returnValue[2]);
			else
				parent.addSibling(paramsForForm[0],returnValue[0],returnValue[1],returnValue[2]);
		}
		if(paramsForForm[1] == 7){
			document.XMLTreeForm.XMLEntry.value = "<"+returnValue[0]+"/>";
			returnXML = document.XMLTreeForm.XMLEntry.value;
			openXMLEditor(returnXML);
		}
     }
     else
     if (dialogName=='kxyMsgFr')
     {
     	message_win = 0;
	debug_html=returnValue[1];
	debug_request=returnValue[2];
	debug_resp=returnValue[3];
	debug_r=returnValue[4];
	debug_p=returnValue[5];
	debug_On=returnValue[6];
	debugwin=returnValue[7];

 	if (debugwin!=null)
  	{
  		debugwin = null;
		M_debugger();
		debugwin.blur();
 	}
	windowOpen=returnValue[8];
	timeOut = returnValue[9];

	if(timeOut == 1)
	{
		initializeTimeOut();
	}
	else
	if(timeOut == 2)
	{
		initializeLogout();
	}	
	else
	{
		if (returnValue[0]=='logout'){
			M_logout();
			return;
		}

		if(QType == TYPEMQ)
		{
			var q_attrib = M_DisplayQueue([paramsForForm[7]],["CURDEPTH"]);

			if(q_attrib != null && frame2.frame3.document.getElementById('td_'+paramsForForm[7]) != null)
			{
				var q_depth = getTag("//CURDEPTH",q_attrib);
				if(q_depth != null)
					frame2.frame3.document.getElementById('td_'+paramsForForm[7]).innerHTML = "<font class='MessageAttrib'><b>"+q_depth+"</b></font>";
				else
					frame2.frame3.document.getElementById('td_'+paramsForForm[7]).innerHTML = "<font class='MessageAttrib'><b></b></font>";
			}
		}
	}
	return;
     }
     else
     if (dialogName=='kxyJsErr')
     {
    	if (returnValue==1)
		M_debugger();
	else
	        debug_On=true;
     }
     else
     if(dialogName == 'kxyEdtFr' || dialogName == 'kxyEdJMF')
     {
	     if(paramsForForm[2].length == 0)
	     {
			return returnValue;
	     }
	     else
	     {
     		xmlResult = returnValue;
		needcommit=true;
	
		if(ccode && ccode == "KXY_ERR_BUFFER_FULL")
		{
			M_alert(err_273);
			bufferFull = true;
		}
		var updatedMsg = getTag("//Completion",xmlResult,browser);
		if(updatedMsg && updatedMsg > 1)
		{
			var xmlResult2=M_RefreshMsg();
			pendingMessages(5, xmlResult2);
		}		
		else
		{
			var xmlResult2=M_RefreshMsg();
			pendingMessages(2, xmlResult2);
		}
		M_alert(err_246);
	     }
    	 }
    	 else
     	if(dialogName == 'kxyCrtFr' || dialogName == 'kxyCrJMF')
     	{
     		if(paramsForForm[0] == "raw_format" && QType != TYPEMQ)
     		{
			if(typeof returnValue == "string" && (returnValue == "Stream" || returnValue == "Map"))
     			{
     				ShowWindow('kxyCrJMF','','700px','650px',["raw_format",'',"",returnValue,getHandle(),getConnid(),getQType(),getBrowser(),0,"",getActiveQmgr(),getQueueName(),'',url,mbcsXML]);
     				return;
     			}
     		}
     		
     		xmlResult = returnValue;
     		var ccode =  getTag(CCODE,xmlResult,browser);
		needcommit=true;
		M_alert(err_239);
		if(ccode && ccode == "KXY_ERR_BUFFER_FULL")
		{
			M_alert(err_273);
			bufferFull = true;
		}
		var xmlResult2=M_RefreshMsg(); 
		pendingMessages(1, xmlResult2);
     	}
   	else
	if (dialogName=='kxyXMLTr')
	{
		document.XMLTreeForm.optionXML[0].checked = true;
		
		var return_xml = getXMLTag("//Body/*",returnValue);
		
		var node = document.getElementById('XMLEntry');
		
		node.value= "";
		
		var resultXML = return_xml.xml;
		/*node.insertAdjacentText("beforeEnd",resultXML);
		alert(node.innerText);*/
		
		setTextAreaContent("STRING",resultXML);
		updateValue(resultXML);
	}
	else
	{
		if(typeof returnValue == "string")
			params1 = returnValue.split(";");
		if (dialogName=='kxyappfi'){
			M_applyFiltersPeek(params1);
		}
		if(dialogName == 'kxynwJMS')
		{
			param2 = params1;
			setCursor(3);
		}
		if(dialogName == 'kxyupJMS')
		{
			param2 = params1;
			setCursor(4);
		}
		if(dialogName == 'kxynewCl' || dialogName == 'kxynewCl2')
		{
			param2 = returnValue;
			setCursor(1);
		}
		if(dialogName == 'kxyupdC' || dialogName == 'kxyupdC2')	
		{
			param2 = returnValue;
			
			setCursor(2);
		}
		if(dialogName == 'kxycrtQ' || dialogName == 'kxyCrQJM')
		{
			param2 = returnValue;
			setCursor(7);
		}
		if(dialogName == 'kxydelW')
		{  		
			param2 = paramsForForm[0];
			param3 = returnValue;
			setCursor(8);
		}
		if(dialogName == 'kxyopnQ')
		{
			var paramsFinal = new Array();
			paramsFinal[0] = paramsForForm[1];

			for(i=0;i<params1.length;i++)
				paramsFinal[i+1] = params1[i];
			paramsFinal[paramsFinal.length] = paramsForForm[19];
			param2 = paramsFinal;
			setCursor(14);
		}
		if(dialogName == 'kxyoQJMS'){
			var paramsFinal = new Array();
			paramsFinal[0] = paramsForForm[1];

			for(i=0;i<params1.length;i++)
				paramsFinal[i+1] = params1[i];

			M_openQueue(paramsFinal);
		}
		if(dialogName == 'kxyPaste'){
		    M_paste(params1);  	

		}
		if(dialogName == 'kxyLoadW'){
		    M_load(params1);  	

		}
		if(dialogName == 'kxyULoWn'){
		    M_unload(params1[0],params1[1],params1[2],params1[3],params1[4],params1[5],params1[6],params1[7]);  	

		}
		if(dialogName == 'kxydelMW'){
			if(params1[0] == 'yes'){
				if(paramsForForm[2] == 9)
				{
					M_deleteVariant(paramsForForm[0]);
				}
				else
				if(paramsForForm[2] == 8)
				{
					M_delFilter(paramsForForm[0]);
				}
				if(paramsForForm[2] == 6)
				{
					param2 = paramsForForm[0];
					setCursor(9);
				}
				else
				if(paramsForForm[2] == 5)
					deleteProperty(paramsForForm[3]);
				else
				if(paramsForForm[2] == 4)
				{
					for(var i = 0; i < paramsForForm[3].length; i++)
						deleteProperty(i,paramsForForm[3][i]);
				}
				else
				if(paramsForForm[2] == 1)
				{
					param2 = paramsForForm;
					setCursor(5);
				}	
				else
				if(paramsForForm[2] == 2)
				{
					param2 = paramsForForm;
					setCursor(6);
				}
				else
				if(paramsForForm[2] == 0)
				{
					param2 = paramsForForm[3];
					setCursorTable(60);
				}
				else
				if(paramsForForm[2] == 7)
					M_deleteMsg(''); 
			}	    	

		}
		if(dialogName == 'kxyForWn'){
		    if(browser == "NS")
			M_forward(params1[0],params1[1],beginNS);  	
		    else
			M_forward(params1[0],params1[1],begin);  	
		    return;
		}
		if(dialogName == 'kxyFoDLQ'){
			    M_forward(params1[0],params1[1],begin,params1[2],params1[3]);  	

   	}

   	if(dialogName == 'kxyStFmt'){
   		if(params1[0] != "no")
   		{
   			param2 = params1[0];
   			param3 = params1[1];
   			setCursorTable(73);
  	    	}
  	    	else
  	    	if(params1[0] != "")
  	    	{
  	    		if(getQType() == TYPEMQ)
  	    			ShowWindow('kxyCrtFr','','700px','650px',["raw_format","","","",getHandle(),getConnid(),getQType(),getBrowser(),0,"",getActiveQmgr(),getQueueName(),'',url,mbcsXML]);	
  	    		else
				ShowWindow('kxyCrJMF','','700px','650px',["raw_format","","","",getHandle(),getConnid(),getQType(),getBrowser(),0,"",getActiveQmgr(),getQueueName(),'',url,mbcsXML]);	
	      	}	
   	}
   	if(dialogName == 'kxyStFmJ'){
   		if(params1[0] == "MDR")
  	    		M_createMsgW(params1[1],params1[2]); 
  	    	else
  	    	{
  	    		if(params1[0] == "Text")
  	    			var type = "RAW_TEXT";
  	    		else
    	    		if(params1[0] == "Hex")
  	    			var type = "RAW_HEXA";
  	    		else
   	    		if(params1[0] == "XML")
  	    			var type = "STANDALONE";
  	    		else
  	    			var type = params1[0];
			
    	    		var param = ["raw_format","","",type,getHandle(),getConnid(),getQType(),getBrowser(),0,"",getActiveQmgr(),getQueueName(),'',url,mbcsXML]
  	    		if(getQType() == TYPEMQ)
  	    			ShowWindow('kxyCrtFr','','700px','650px',param);	
  	    		else
				ShowWindow('kxyCrJMF','','700px','650px',param);	
	      	}
   	}
	if (dialogName=='kxyalert')
	{
		var checkID = document.getElementById('checkAll');
		if(checkID)
			checkID.focus();
	}
	if (dialogName=='kxyFind')
	{
		if (params1[1]=='Find')
			M_find(paramsForForm,params1[0],'first');
		else
			M_find(paramsForForm,params1[0],'next');
	}
	if (dialogName=='kxyfinms')
	{
		if (browser=="NS") 
			contFind(returnValue,paramsForForm[2],paramsForForm[3],paramsForForm[4],paramsForForm[5],paramsForForm[6],paramsForForm[7],paramsForForm[8]);
	}
	if (dialogName=='kxyconf')
	{
		if (browser=="NS")
		{
			if(paramsForForm[1] != null)
			{
  		 		loadingMessage("Loading...");
		 		M_nav(paramsForForm[1],document.MessageForm.depthM.value);			
			}
			else
			{
				contReplaceClose(returnValue);
				return;
			}
		}
		
	}
	if (dialogName=='kxyRepl')
	{
		if(browser == "NS")
		{
		   if(params1[2] != null)
		   {
			if (params1[0]=='true')
	 		{
				var doapply=ShowWindow("kxyconf","",'550px','170px',["Message",params1[2]]);
				return;
			}		
		   }
		   else
		   {
 			if (params1[0]=='true')
	 		{
				var doapply=ShowWindow("kxyconf","",'550px','170px',["Message"]);
				return;
			}
			
	 		if (params1[1]=='true')
	 		{
				setPointerTableRefresh(null,true);
				needtoUpdate=false;
	  		}else
	  		{
		 		columnOff(1);
		 		captureEvent();
		 	}
	
			win=null;
		     }

		}
	     
	}
	if (dialogName=='kxyHexAp')
	{
		var hexFound = 0;
		//M_setHexValue(hexPathSelected,params1[0],selectedConID);
		for(u=0; u < hexArrayIndex;u++){
			if(hexFieldName[u] == hexPathSelected){
				hexFieldValue[u] = params1[0];
				hexFound = 1;
			}
		}
		if(hexFound == 0){
			hexFieldName[hexArrayIndex] = hexPathSelected;
			hexFieldValue[hexArrayIndex] = params1[0];
			hexArrayIndex ++;
 		}
		nodeSel.childNodes[0].nodeValue="Updated Hex Value";
		subNodes(arrayNode1,arrayNode2,arrayNode3,arrayNode4,arrayNode5,arrayNode6,1,arrayNode7);	
	}
	if (dialogName=='kxyHexCr')
	{
		var result = null;
		if(parseInt(returnValue[2]) == 2)
			M_alert(returnValue[0]);
		else
		{
			if(paramsForForm[8] == 1)
				result = M_getText(returnValue[0],paramsForForm[2]);
			if(result == null)
				decideStringOrHex(returnValue[2],returnValue[1],returnValue[0]);
			else
			{
				if(result[1] == "Hexa")
					decideStringOrHex("0",returnValue[1],result[0]);
				else
					decideStringOrHex("1",result[0],returnValue[0]);
			}
		}
	}
	if (dialogName=='kxyPrint')
	{
		if(params1[0] == "print")
		{
			if(parent.frame8 != null )
			{
				parent.frame8.document.getElementById('messagesPrint').innerHTML = DocumentToPrint;
				parent.frame8.focus();
				parent.frame8.print();
			}
			else
			if(parent.frame6 != null)
			{
				parent.frame6.document.getElementById('messagesPrint').innerHTML=  DocumentToPrint;
				parent.frame6.focus();
				parent.frame6.print();
			}
			else
			if(parent.frame10 != null)
			{
				parent.frame10.document.getElementById('messagesPrint').innerHTML=  DocumentToPrint;
				parent.frame10.focus();
				parent.frame10.print();
			}

		}
				
	}
	if (dialogName=='kxySvVar')
	{
		M_addVariant(params1[0],paramsForForm[0],paramsForForm[1],paramsForForm[2],paramsForForm[3]);
	}
	if (dialogName=='kxyColFi'){
		if(params1[3] == '0' || params1[3] == 0)
			M_saveFilter(params1[0],'column',params1[1],params1[2],'',params1[4]);
		else
			M_updateFilter(params1[0],'column',params1[1],params1[2],params1[4]);
				
	}
     	else
     	if (dialogName=='kxyDelFi')
     	{
   		if(params1[0] == "filter")
   		{
     			if(params1[1] == selectedFilter)
     				clearFilt();
   			M_alert(err_337);
   		}
   		if(params1[0] == "variant")
   		{
     			if(params1[1] == selected_variant)
     				clearVariant();
   			M_alert(err_341);
   		}
   	}
	if (dialogName=='kxyopt')
	{
		if (params1[1]=='true')
			M_debugger();
		if (params1[0]=='true')
			debug_On=true;
		else
			debug_On=false;
	}
	
	if (dialogName=='kxyGetVa')
	{
	 	showVariant(params1[0],params1[1],params1[2],params1[3]);
        }
 	if (dialogName=='kxyVarDe')
 	{
 		if(browser == "NS")
 	 		ShowWindow('kxySvVar','','550px','220px',[params1[0],params1[1],params1[2],params1[3]]);
        }
 	if (dialogName=='kxyStAtt')
 	{
 	 	selectedAttrib = returnValue;
 	 	counter++;
        }
 	if (dialogName=='kxyAdPro')
 	{
 		if(paramsForForm[1] == '')
			createProperty(params1[0],params1[1],params1[2],paramsForForm[2]);
		else
			updateProperty(params1[0],params1[1],params1[2],paramsForForm[1][3]);
		
        }
 	if (dialogName=='kxyClPro')
 	{
		nameArray = returnValue[0];
		valueArray = returnValue[1];		
        }
 	if (dialogName=='kxyCLgPr')
 	{
		newNodeName = returnValue[0];
		newNodeValue = returnValue[1];		
        }
 	if (dialogName=='kxyClLog')
 	{
 		parent.setPointer(paramsForForm[2],'MQSeries',paramsForForm[2],'','',returnValue);	
        }
 	if (dialogName=='kxyRePro')
 	{
 		displayDelete(4,params1);
        }
 	if (dialogName=='kxyStMap')
 	{
 		displayDelete(4,params1);
        }
     }
}
else
{
	if (dialogName=='kxyHexCr' || dialogName=='kxyHexDump')
	{
		if(hexValueFlag == 0)
			var p2 = "1";
		else
			var p2 = "0";
		decideStringOrHex(p2)
	}
}
}


function serializeXML (xmlDocument)
{
  var xmlSerializer;
  try {
    xmlSerializer = new XMLSerializer();
    return xmlSerializer.serializeToString(xmlDocument);
  }
  catch (e) {
    //M_alert("Can't serialize XML document.");
    return '';
  }
}

function _Node_getXML() {
    
    //create a new XMLSerializer
    var objXMLSerializer = new XMLSerializer;
    
    //get the XML string
    var strXML = objXMLSerializer.serializeToString(this);
    
    //return the XML string
    return strXML;
}

function createXMLFromString (string) {
  var xmlParser, xmlDocument;
  try {
    xmlParser = new DOMParser();
    xmlDocument = xmlParser.parseFromString(string, 'text/xml');
    return xmlDocument;
  }
  catch (e) {
    M_alert(err_328);
    return null;
  }
}



function setCursor(flag)
{
	if (frame1.document.all)
	for (var i=0;i < frame1.document.all.length; i++)
		frame1.document.all(i).style.cursor = 'wait';
	if(frame2.document.all)
	{
		for (var i=0;i < frame2.document.all.length; i++)
			frame2.document.all(i).style.cursor = 'wait';
	}
	//if(frame2.frame3.document.all)
	//{
	//	for (var i=0;i < frame2.frame3.document.all.length; i++)
	//		frame2.frame3.document.all(i).style.cursor = 'wait';
	//}
	
	param1 = flag;
	setTimeout('actionAfterTimeout()',1);
}


function resetCursor()
{
	if (frame1.document.all)
	for (var i=0;i < frame1.document.all.length; i++)
		frame1.document.all(i).style.cursor = 'auto';
	if(frame2.document.all)
	{
		for (var i=0;i < frame2.document.all.length; i++)
			frame2.document.all(i).style.cursor = 'auto';
	}
	//if(frame2.frame3.document.all)
	//{
	//	for (var i=0;i < frame2.frame3.document.all.length; i++)
	//		frame2.frame3.document.all(i).style.cursor = 'auto';
	//}
}



function setCursorTable(flag)
{
	/*if (document.all)
	for (var i=0;i < document.all.length; i++)
		document.all(i).style.cursor = 'wait';
	*/
		
	document.body.style.cursor = 'wait';
	if(document.getElementById('buttonId') != null)
		document.getElementById('buttonId').style.cursor = 'wait';
	
	param1 = flag;
	setTimeout('actionAfterTimeout()',1);
}


function resetCursorTable()
{
	document.body.style.cursor = 'auto';
	if(document.getElementById('buttonId') != null)
		document.getElementById('buttonId').style.cursor = 'auto';
}



function setCursorDialog(flag)
{  
	if (document.all){
		//DCC the following will lead to performance when there are lot of xml node's there
		//for (var i=0;i < document.all.length; i++)
		//	document.all(i).style.cursor = 'wait';
		document.body.style.cursor = 'wait';
	}
	
	param1 = flag;
	setTimeout('actionAfterTimeout()',1);
}


function resetCursorDialog()
{
	if (document.all){
		//DCC the following will lead to performance when there are lot of xml node's there
		//for (var i=0;i < document.all.length; i++)
		//document.all(i).style.cursor = 'auto';
		document.body.style.cursor = 'auto';
	}
}





function actionAfterTimeout()
{
	switch(param1)
	{
		case 1: M_addNewClientConnection(param2); resetCursor();break;
		case 2: M_updateClientConnection(param2); resetCursor();break;
		case 3: M_addNewJMS(param2); resetCursor();break;
		case 4: M_updateJMS(param2); resetCursor();break;
		case 5: M_removeClientConnection(param2); resetCursor();break;
		case 6: M_removeJMS(param2); resetCursor();break;
		case 7: M_createQueue(param2); resetCursor();break;
		case 8: M_delete(param2, param3); resetCursor();break;
		case 9: M_ClearQueue(param2); resetCursor();break;
		case 10: showQueueAttributes(param2); resetCursor();break;
		case 11: M_RefreshQueues(); resetCursor();break;
		case 12: ShowMyHelp(''); resetCursor();break;
		case 13: openQDialog(param2,param3,param4); resetCursor();break;
		case 14: M_openQueue(param2); resetCursor();break;
		case 15: M_displayFilterMsg(); resetCursor();break;
		case 16: M_displayColumnFilter(); resetCursor();break;
		case 17: M_OpenVariantDefinitionDialog(); resetCursor();break;
		case 18: M_debugger(); resetCursor();break;
		case 19: M_chooseFmt(); resetCursorTable(); break;
		case 20: printOperation(getActiveQmgr(),getQueueName());resetCursorTable(); break;
		case 21: printPreview(getActiveQmgr(),getQueueName());resetCursorTable(); break;
		case 22: ShowMyHelp('');resetCursorTable(); break;
		case 23: M_debugger();resetCursorTable(); break;
		case 24: M_displayForward(); resetCursorTable(); break;
		case 25: M_displayFind();resetCursorTable(); break;
		case 26: M_displayReplace();resetCursorTable(); break;
		case 27: M_displayFilterMsg();resetCursorTable(); break;
		case 28: M_displayColumnFilter();resetCursorTable(); break;
		case 29: M_displayApplyFilters();resetCursorTable(); break;
		case 30: M_OpenVariantDefinitionDialog();resetCursorTable(); break;
		case 31: openLoadDialog();resetCursorTable(); break;
		case 32: openUnloadDialog(); resetCursorTable(); break;
		case 33: openFilt(); resetCursorTable(); break;
		case 34: delFilter(); resetCursorTable(); break;
		case 35: ShowMyHelp('row_filter_editor'); resetCursorTable(); break;
		case 36: M_displayDel('column'); resetCursorTable(); break;
		case 37: ShowMyHelp('column_filter_editor'); resetCursorTable(); break;
		case 38: retrieveVariant(); resetCursorTable(); break;
		case 39: M_displayDel('variant'); resetCursorTable(); break;
		case 40: ShowMyHelp('var_def_editor'); resetCursorTable(); break;
		case 41: printLog(); resetCursorTable(); break;
		case 42: window_onclose(); resetCursorTable(); break;
		case 43: ShowMyHelp('select_format'); resetCursorTable(); break;
		case 44: showAll(); resetCursorTable(); break;
		case 45: OpenHelpDialog(); resetCursorTable(); break;
		case 46: printLog(); resetCursorTable(); break;
		case 47: ShowHelpForward(); resetCursorTable(); break;
		case 48: ShowMyHelp('forward_messages_dlq'); resetCursorTable(); break;
		case 49: ShowMyHelp('find'); resetCursorDialog(); break;
		case 50: ShowMyHelp('replace'); resetCursorTable(); break;
		case 51: ShowMyHelp('apply_filters'); resetCursorTable(); break;
		case 52: ShowMyHelp('load_msgs'); resetCursorTable(); break;
		case 53: getAvailFiles(); resetCursorTable(); break;
		case 54: ShowMyHelp('unload_msgs'); resetCursorTable(); break;
		case 55: getAvailFiles(); resetCursorTable(); break;
		case 56: M_copyMsg(); resetCursorTable(); break;
		case 57: M_copyMsg([selectedElement]); resetCursorTable(); break;
		case 58: setPointerPaste('no'); resetCursorTable(); break;
		case 59: M_displayDelete(); resetCursorTable(); break;
		case 60: M_deleteMsg(param2); resetCursorTable(); break;
		case 61: window_oncloseFind(); resetCursorDialog(); break;
		case 62: window_oncloseNext(); resetCursorDialog(); break;
		case 63: window.close(); break;
		case 64: window_oncloseReplace(); resetCursorDialog(); break;
		case 65: window_oncloseReplaceall(); resetCursorDialog(); break;
		case 66: window_apply(); resetCursorDialog(); break;
		case 67: M_closeQ(null); resetCursorTable(); break;
		case 68: M_commit(); resetCursorTable(); break;
		case 69: M_rollback(); resetCursorTable(); break;
		case 70: displayAvailableFilters(); resetCursorDialog(); break;
		case 71: M_closeQ("logout"); resetCursorTable(); break;
		case 72: M_logout(); resetCursor();break;
		case 73: M_createMsgW(param2,param3); resetCursorTable(); break;
		case 74: openHeaderEditor(1,kxyType); resetCursorDialog(); break;
		case 75: window_onclose(); resetCursorDialog(); break;
		case 76: ShowMyHelp('retrieve_filters'); resetCursorDialog(); break;
		case 77: selectFormat(param2, param3, param4); resetCursorDialog(); break;
		case 78: save(); resetCursorDialog(); break;
		case 79: ValidateForm('SaveFilt'); resetCursorDialog(); break;
		case 80: ShowMyHelp('save_filter'); resetCursorDialog(); break;
		case 81: ShowHelp(); resetCursorDialog(); break;
		case 82: clearFilt(); resetCursorDialog(); break;
		case 83: clearVariant(); resetCursorDialog(); break;
		case 84: ShowMyHelp('retrieve_variants'); resetCursorDialog(); break;
		case 85: displayAvailableVariants(); resetCursorDialog(); break;
		case 86: ShowMyHelp('options'); resetCursorDialog(); break;
		case 87: ShowMyHelp('message_window'); resetCursorDialog(); break;
		case 88: printOperationTree(printObj,0,0,0,qmgr,qname); resetCursorDialog(); break;
		case 89: printPreviewTree(printObj,0,0,0,qmgr,qname); resetCursorDialog(); break; 
		case 90: printOperationTree(XMLDOMobj,printNo,seqNo,qDepth,qmgr,qname); resetCursorDialog(); break;
		case 91: printPreviewTree(XMLDOMobj,printNo,seqNo,qDepth,qmgr,qname); resetCursorDialog(); break;
		case 92: ShowMyHelp('xml_tree_editor'); resetCursorDialog(); break; 
		case 93: ShowMyHelp('hex_editor'); resetCursorDialog(); break; 
		case 94: openHexApplet('',editOrCrtFlag); resetCursorDialog(); break; 
		case 95: M_cutMsg(); resetCursorTable(); break;
		case 96: ShowMyHelp('update_connection_jms'); resetCursorDialog(); break; 
		case 97: ShowMyHelp('update_connection_wmq'); resetCursorDialog(); break; 
		case 98: showOtherProperties(); resetCursorDialog(); break; 
		case 99: selectAllAtt(); resetCursorDialog(); break;
		case 100: ShowMyHelp('select_header_fields'); resetCursorDialog(); break;
		case 101: selectAllProp(); resetCursorDialog(); break;
		case 102: ShowMyHelp('open_queue_jms'); resetCursorDialog(); break;
		case 103: validateCount(document.OpenQueueForm.count.value); resetCursorDialog(); break;
		case 104: ShowMyHelp('open_queue_wmq'); resetCursorDialog(); break;
		case 105: ShowMyHelp('new_connection_jms'); resetCursorDialog(); break;
		case 106: ValidateForm(); resetCursorDialog(); break;
		case 107: ShowMyHelp('new_connection_wmq'); resetCursorDialog(); break;
		case 108: showAttributesDialog(); resetCursorDialog(); break;
		case 109: clearLog(); resetCursorTable(); break;
		case 110: saveLog(); resetCursorTable(); break;
		case 111: ShowMyHelp('new_queue_wmq'); resetCursorDialog(); break;
		case 112: ShowMyHelp('props_general'); resetCursorDialog(); break;
		case 113: ShowMyHelp('props_triggerconditions'); resetCursorDialog(); break;
		case 114: ShowMyHelp('props_eventcontrol'); resetCursorDialog(); break;
		case 115: ShowMyHelp('props_backout'); resetCursorDialog(); break;
		case 116: ShowMyHelp('props_remotequeue'); resetCursorDialog(); break;
		case 117: ShowMyHelp('props_aliasqueue'); resetCursorDialog(); break;
		case 118: ShowMyHelp('new_queue_jms'); resetCursorDialog(); break;
		case 119: window_onclose(1); resetCursorDialog(); break;
		case 120: window_onclose(2); resetCursorDialog(); break;
		case 121: ShowMyHelp('client_connection_login'); resetCursorDialog(); break;
		case 122: ShowMyHelp('client_connection_login_other_properties'); resetCursorDialog(); break;
		case 123: ShowMyHelp('client_connection_other_properties'); resetCursorDialog(); break;
		case 124: M_RefreshQueues('Name'); resetCursor(); break;
		case 125: M_RefreshQueues('Type'); resetCursor(); break;
		case 126: M_RefreshQueues('Depth'); resetCursor(); break;
		case 127: openHexdumpApplet('',editOrCrtFlag); resetCursorDialog(); break; 
	}
}
