/*
#$Id: kxyutil.js,v 1.7 2003/10/14 18:28:45 rbais Exp $#
######################################################################
# Copyright 1999-2003, Candle Corporation, a California corporation.  
# All rights reserved. International copyright secured.
#
# This material is proprietary to Candle Corporation and is not to be
# reproduced, used, or disclosed except in accordance with program
# licenses or upon written authorization of Candle Corporation.
#
#######################################################################*/
function checkEnterKey(e) {
	if(window.event || !e.which) // IE
	{
		key = e.keyCode; // for IE, same as window.event.keyCode
	}
	else if(e) // netscape
	{
		key = e.which;
	}

    	if (key == 13)
    	{
		e.returnValue = false;
		//if(focusEvent)
		//	focusEvent[fieldOnFocus];
	}
	if(key == 27)
	{
		e.returnValue = false;
		window.close();
	}
}


function enterKeyEnable(e)
{

	if(window.event || !e.which) // IE
	{
		key = e.keyCode; // for IE, same as window.event.keyCode
	}
	else if(e) // netscape
	{
		key = e.which;
	}

	if(key == 13)
	{
		e.returnValue = false;
		window_onclose();
	}
	if(key == 27)
	{
		e.returnValue = false;
		window.close();
	}
}


function checkQuotes(val)
{
	var temp = val;
	for(var i = 0; i < val.length; i++)
	{
		if(val.charAt(i) == '"')
		{
			temp = val.substring(0,i)
			temp += "&quot;";
			temp += val.substring(i+1,val.length);
			val = temp;
			i++;
		}
	}
	return temp;
}


function checkBlank(val)
{
	var temp = val;
	for(var i = 0; i < val.length; i++)
	{
		if(val.charAt(i) == ' ')
		{
			temp = val.substring(0,i)
			temp += "&nbsp;";
			temp += val.substring(i+1,val.length);
			val = temp;
			i++;
		}
	}
	return temp;
}


function checkBackSlash(val)
{
	var temp = val;
	for(var i = 0; i < val.length; i++)
	{
		if(val.charAt(i) == '\\')
		{
			temp = val.substring(0,i)
			temp += "\\\\";
			temp += val.substring(i+1,val.length);
			val = temp;
			i++;
		}
	}
	return temp;
}



function checkSpecialChars(val)
{
	var temp = val;
	for(var i = 0; i < val.length; i++)
	{
		if(val.charAt(i) == '"')
		{
			temp = val.substring(0,i)
			temp += "&quot;";
			temp += val.substring(i+1,val.length);
			val = temp;
			i++;
		}
		else
		if(val.charAt(i) == '<')
		{
			temp = val.substring(0,i)
			temp += "&lt;";
			temp += val.substring(i+1,val.length);
			val = temp;
			i++;
		}
		else
		if(val.charAt(i) == '>')
		{
			temp = val.substring(0,i)
			temp += "&gt;";
			temp += val.substring(i+1,val.length);
			val = temp;
			i++;
		}
	}
	return temp;
}



function nocontextmenu()
 {
  if (window.Event)
   {
    return false;
   }
  else
    {
     event.cancelBubble = true
     event.returnValue = false;
     return false;
    }
 }
 
 
 

function checkWholeNumber(val){
	for(var i=0; i<val.length;i++){
		if(val.charAt(i) == "."){
			return false;
		}
	}
	return true;

}


function checkForSpace(tempName){
	var valid = 1;
	for(var a = 0; a <tempName.length;a++){
		var temp = tempName.charAt(a);
		if(temp == ' ')
		{
			valid = 0;
			break;
		}
	}
	return valid;
}



/**********************************************************************************************
The function rtrim truncates any spaces on the right side in the queue names returned from the 
server modal dialog window for Opening a Queue. It takes the following argument:
argvalue	: is the name of the Queue for which the spaces in its name are to be truncated.
***********************************************************************************************/
function rtrim(argvalue) {
  while (1) {
    if (argvalue.substring(argvalue.length - 1, argvalue.length) != " ")
      break;
    argvalue = argvalue.substring(0, argvalue.length - 1);
  }
  return argvalue;
}


function ltrim (s)
{
	//DCC avoid out of memory
	if(s.length>16777216)
		return s;
		
	var re = /^\s*/;
	var a = "";
	return s.replace( re, a );
}



function isValid(string,not_allowed) {
    for (var i=0; i< string.length; i++) {
       if (not_allowed.indexOf(string.charAt(i)) != -1)
          return false;
    }
    return true;
}


function get_url()
{
if (getBrowser()=="NS"){
  var query1 = location.href   // Get the query string
  var pos1=query1.indexOf("/");
  var tmp1=query1.substring(pos1+2,query1.length); 
  pos2=tmp1.indexOf("/");
  var tmp2=tmp1.substring(pos2+1,query1.length);
  url_ini=query1.substring(0,pos1+pos2+2); 
  return url_ini;
}else{
	 var proto=location.protocol;
	 var host=location.host;
	 var aux= proto+"//"+host;
	 return aux;
	
 }


}

function parseQueryString (str) {
  str = str ? str : location.search;
  var query = str.charAt(0) == '?' ? str.substring(1) : str;
  var args = new Object();
  if (query) {
    var fields = query.split(';');
    for (var f = 0; f < fields.length; f++) {
      var field = fields[f].split('=');
      args[unescape(field[0].replace(/\+/g, ' '))] = 
unescape(field[1].replace(/\+/g, ' '));
    }
  }
  return args;
}

function getBrowser()
{
   var brName= navigator.appName;
   if (brName=='Microsoft Internet Explorer')
	return "ie";
   else 
	return "NS";
}



//*****************************************************************************************************************************
// functions to get the position of a tag
//*****************************************************************************************************************************

function getAnchorPosition(anchorname,type) {

	// This function will return an Object with x and y properties
	var useWindow=false;
	var coordinates=new Object();
	var x=0,y=0;
	// Browser capability sniffing
	var use_gebi=false, use_css=false, use_layers=false;
	if (document.getElementById) { use_gebi=true; }
	else if (document.all) { use_css=true; }
	else if (document.layers) { use_layers=true; }
	// Logic to find position
	
 	if (use_gebi && document.all) {
 	if(type == 'msg'){
		x=AnchorPosition_getPageOffsetLeft(document.all[anchorname]);
		y=AnchorPosition_getPageOffsetTop(document.all[anchorname]);
	}
	else
 	if(type == 'list'){
		x=AnchorPosition_getPageOffsetLeft(parent.parent.frame2.frame3.document.all[anchorname]);
		y=AnchorPosition_getPageOffsetTop(parent.parent.frame2.frame3.document.all[anchorname]);
	}
	else{
		x=AnchorPosition_getPageOffsetLeft(parent.parent.frame1.document.all[anchorname]);
		y=AnchorPosition_getPageOffsetTop(parent.parent.frame1.document.all[anchorname]);	
	}
		}
	else if (use_gebi) {
		if(type == 'msg'){
			var o=document.getElementById(anchorname);
			x=o.offsetLeft; y=o.offsetTop;
		}
		else
		if(type == 'list'){
			var o=parent.parent.frame2.frame3.document.getElementById(anchorname);
			x=o.offsetLeft; y=o.offsetTop;
		}
		else{
			var o=parent.parent.frame1.document.getElementById(anchorname);
			x=o.offsetLeft; y=o.offsetTop;
		}

	}
 	else if (use_css) {
		x=AnchorPosition_getPageOffsetLeft(document.all[anchorname]);
		y=AnchorPosition_getPageOffsetTop(document.all[anchorname]);
		}
	else if (use_layers) {
		var found=0;
		for (var i=0; i<document.anchors.length; i++) {
			if (document.anchors[i].name==anchorname) { found=1; break; }
			}
		if (found==0) {
			coordinates.x=0; coordinates.y=0; return coordinates;
			}
		x=document.anchors[i].x;
		y=document.anchors[i].y;
		}
	else {
		coordinates.x=0; coordinates.y=0; return coordinates;
		}
	coordinates.x=x;
	coordinates.y=y;
	return coordinates;
	}


// Functions for IE to get position of an object
function AnchorPosition_getPageOffsetLeft (el) {
	var ol=el.offsetLeft;
	while ((el=el.offsetParent) != null) { ol += el.offsetLeft; }
	return ol;
	}
function AnchorPosition_getWindowOffsetLeft (el) {
	return AnchorPosition_getPageOffsetLeft(el)-document.body.scrollLeft;
	}	
function AnchorPosition_getPageOffsetTop (el) {
	var ot=el.offsetTop;
	while((el=el.offsetParent) != null) { ot += el.offsetTop; }
	return ot;
	}
function AnchorPosition_getWindowOffsetTop (el) {
	return AnchorPosition_getPageOffsetTop(el)-document.body.scrollTop;
	}
	

//*******************************************************************************
// MetaData functions
//*******************************************************************************


function MaxCard(xml,path)
{
  return getAttrib(xml,path,MAXCARD);
}

function MinCard(xml,path)
{
 return getAttrib(xml,path,MINCARD);
}

function MaxLength(xml,path)
{
 return getAttrib(xml,path,MAXLENGTH);
}

function MinLength(xml,path)
{
 return getAttrib(xml,path,MINLENGTH);
}

function getTypeAttribute(xml,path)
{
 return getAttrib(xml,path,"kxyType");
}

//*******************************************************************************
// Sleep functions
// Usage:
//   Sleep(this,500);
//   this.NextStep=function(){...}
// Note:this function will not work correctly if it was used in async mode
// 
//*******************************************************************************
function Sleep(obj,iMilliSeconds)
{ 
   if (window.eventList==null) 
   window.eventList=new Array(); 
   var ind=-1;
   for (var i=0;i<window.eventList.length;i++)
   {  
    if (window.eventList[i]==null) 
    { 
     window.eventList[i]=obj;   
     ind=i;  
     break;  
    } 
   } 
   if (ind==-1)
   {  
    ind=window.eventList.length;  
    window.eventList[ind]=obj;
   } 
   setTimeout("GoOn(" + ind + ")",iMilliSeconds);
}

function GoOn(ind)
{ 
   var obj=window.eventList[ind];
   window.eventList[ind]=null;
   if (obj.NextStep) obj.NextStep();
   else obj();
}
